/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.3
 * @date    2022-03-02T13:02:54.265Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
function t(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{},r={exports:{}},n=function(t){return t&&t.Math==Math&&t},i=n("object"==typeof globalThis&&globalThis)||n("object"==typeof window&&window)||n("object"==typeof self&&self)||n("object"==typeof e&&e)||function(){return this}()||Function("return this")(),o={},a=function(t){try{return!!t()}catch(t){return!0}},u=!a((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),s={},c={}.propertyIsEnumerable,l=Object.getOwnPropertyDescriptor,f=l&&!c.call({1:2},1);s.f=f?function(t){var e=l(this,t);return!!e&&e.enumerable}:c;var h,p,v=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},d={}.toString,y=function(t){return d.call(t).slice(8,-1)},g=y,m="".split,b=a((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==g(t)?m.call(t,""):Object(t)}:Object,_=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},w=b,O=_,E=function(t){return w(O(t))},x=function(t){return"object"==typeof t?null!==t:"function"==typeof t},T={},k=T,A=i,S=function(t){return"function"==typeof t?t:void 0},j=function(t,e){return arguments.length<2?S(k[t])||S(A[t]):k[t]&&k[t][e]||A[t]&&A[t][e]},I=j("navigator","userAgent")||"",P=i,D=I,L=P.process,C=P.Deno,M=L&&L.versions||C&&C.version,N=M&&M.v8;N?p=(h=N.split("."))[0]<4?1:h[0]+h[1]:D&&(!(h=D.match(/Edge\/(\d+)/))||h[1]>=74)&&(h=D.match(/Chrome\/(\d+)/))&&(p=h[1]);var R=p&&+p,F=R,z=a,q=!!Object.getOwnPropertySymbols&&!z((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&F&&F<41})),Y=q&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,X=j,W=Y?function(t){return"symbol"==typeof t}:function(t){var e=X("Symbol");return"function"==typeof e&&Object(t)instanceof e},U=x,G={exports:{}},V=i,H=function(t,e){try{Object.defineProperty(V,t,{value:e,configurable:!0,writable:!0})}catch(r){V[t]=e}return e},$=i["__core-js_shared__"]||H("__core-js_shared__",{}),B=$;(G.exports=function(t,e){return B[t]||(B[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.16.1",mode:"pure",copyright:"© 2021 Denis Pushkarev (zloirock.ru)"});var J=_,K=function(t){return Object(J(t))},Q=K,Z={}.hasOwnProperty,tt=Object.hasOwn||function(t,e){return Z.call(Q(t),e)},et=0,rt=Math.random(),nt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++et+rt).toString(36)},it=i,ot=G.exports,at=tt,ut=nt,st=q,ct=Y,lt=ot("wks"),ft=it.Symbol,ht=ct?ft:ft&&ft.withoutSetter||ut,pt=function(t){return at(lt,t)&&(st||"string"==typeof lt[t])||(st&&at(ft,t)?lt[t]=ft[t]:lt[t]=ht("Symbol."+t)),lt[t]},vt=x,dt=W,yt=function(t,e){var r,n;if("string"===e&&"function"==typeof(r=t.toString)&&!U(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!U(n=r.call(t)))return n;if("string"!==e&&"function"==typeof(r=t.toString)&&!U(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},gt=pt("toPrimitive"),mt=function(t,e){if(!vt(t)||dt(t))return t;var r,n=t[gt];if(void 0!==n){if(void 0===e&&(e="default"),r=n.call(t,e),!vt(r)||dt(r))return r;throw TypeError("Can't convert object to primitive value")}return void 0===e&&(e="number"),yt(t,e)},bt=W,_t=function(t){var e=mt(t,"string");return bt(e)?e:String(e)},wt=x,Ot=i.document,Et=wt(Ot)&&wt(Ot.createElement),xt=function(t){return Et?Ot.createElement(t):{}},Tt=xt,kt=!u&&!a((function(){return 7!=Object.defineProperty(Tt("div"),"a",{get:function(){return 7}}).a})),At=u,St=s,jt=v,It=E,Pt=_t,Dt=tt,Lt=kt,Ct=Object.getOwnPropertyDescriptor;o.f=At?Ct:function(t,e){if(t=It(t),e=Pt(e),Lt)try{return Ct(t,e)}catch(t){}if(Dt(t,e))return jt(!St.f.call(t,e),t[e])};var Mt=a,Nt=/#|\.prototype\./,Rt=function(t,e){var r=zt[Ft(t)];return r==Yt||r!=qt&&("function"==typeof e?Mt(e):!!e)},Ft=Rt.normalize=function(t){return String(t).replace(Nt,".").toLowerCase()},zt=Rt.data={},qt=Rt.NATIVE="N",Yt=Rt.POLYFILL="P",Xt=Rt,Wt=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},Ut=Wt,Gt=function(t,e,r){if(Ut(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,i){return t.call(e,r,n,i)}}return function(){return t.apply(e,arguments)}},Vt={},Ht=x,$t=function(t){if(!Ht(t))throw TypeError(String(t)+" is not an object");return t},Bt=u,Jt=kt,Kt=$t,Qt=_t,Zt=Object.defineProperty;Vt.f=Bt?Zt:function(t,e,r){if(Kt(t),e=Qt(e),Kt(r),Jt)try{return Zt(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var te=Vt,ee=v,re=u?function(t,e,r){return te.f(t,e,ee(1,r))}:function(t,e,r){return t[e]=r,t},ne=i,ie=o.f,oe=Xt,ae=T,ue=Gt,se=re,ce=tt,le=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},fe=function(t,e){var r,n,i,o,a,u,s,c,l=t.target,f=t.global,h=t.stat,p=t.proto,v=f?ne:h?ne[l]:(ne[l]||{}).prototype,d=f?ae:ae[l]||(ae[l]={}),y=d.prototype;for(i in e)r=!oe(f?i:l+(h?".":"#")+i,t.forced)&&v&&ce(v,i),a=d[i],r&&(u=t.noTargetGet?(c=ie(v,i))&&c.value:v[i]),o=r&&u?u:e[i],r&&typeof a==typeof o||(s=t.bind&&r?ue(o,ne):t.wrap&&r?le(o):p&&"function"==typeof o?ue(Function.call,o):o,(t.sham||o&&o.sham||a&&a.sham)&&se(s,"sham",!0),d[i]=s,p&&(ce(ae,n=l+"Prototype")||se(ae,n,{}),ae[n][i]=o,t.real&&y&&!y[i]&&se(y,i,o)))};fe({target:"Object",stat:!0,forced:!u,sham:!u},{defineProperty:Vt.f});var he=T.Object,pe=r.exports=function(t,e,r){return he.defineProperty(t,e,r)};he.defineProperty.sham&&(pe.sham=!0);var ve=r.exports,de=ve;function ye(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),de(t,n.key,n)}}function ge(t,e,r){return e&&ye(t.prototype,e),r&&ye(t,r),t}var me=Wt,be=x,_e=[].slice,we={},Oe=function(t,e,r){if(!(e in we)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";we[e]=Function("C,a","return new C("+n.join(",")+")")}return we[e](t,r)},Ee=Function.bind||function(t){var e=me(this),r=_e.call(arguments,1),n=function(){var i=r.concat(_e.call(arguments));return this instanceof n?Oe(e,i.length,i):e.apply(t,i)};return be(e.prototype)&&(n.prototype=e.prototype),n};fe({target:"Function",proto:!0},{bind:Ee});var xe=T,Te=function(t){return xe[t+"Prototype"]},ke=Te("Function").bind,Ae=Function.prototype,Se=function(t){var e=t.bind;return t===Ae||t instanceof Function&&e===Ae.bind?ke:e},je=Math.ceil,Ie=Math.floor,Pe=function(t){return isNaN(t=+t)?0:(t>0?Ie:je)(t)},De=Pe,Le=Math.min,Ce=function(t){return t>0?Le(De(t),9007199254740991):0},Me=Wt,Ne=K,Re=b,Fe=Ce,ze=function(t){return function(e,r,n,i){Me(r);var o=Ne(e),a=Re(o),u=Fe(o.length),s=t?u-1:0,c=t?-1:1;if(n<2)for(;;){if(s in a){i=a[s],s+=c;break}if(s+=c,t?s<0:u<=s)throw TypeError("Reduce of empty array with no initial value")}for(;t?s>=0:u>s;s+=c)s in a&&(i=r(i,a[s],s,o));return i}},qe={left:ze(!1),right:ze(!0)},Ye=a,Xe=function(t,e){var r=[][t];return!!r&&Ye((function(){r.call(null,e||function(){throw 1},1)}))},We="process"==y(i.process),Ue=qe.left,Ge=R,Ve=We;fe({target:"Array",proto:!0,forced:!Xe("reduce")||!Ve&&Ge>79&&Ge<83},{reduce:function(t){return Ue(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var He=Te("Array").reduce,$e=Array.prototype,Be=function(t){var e=t.reduce;return t===$e||t instanceof Array&&e===$e.reduce?He:e},Je=y,Ke=Array.isArray||function(t){return"Array"==Je(t)},Qe=x,Ze=Ke,tr=pt("species"),er=function(t){var e;return Ze(t)&&("function"!=typeof(e=t.constructor)||e!==Array&&!Ze(e.prototype)?Qe(e)&&null===(e=e[tr])&&(e=void 0):e=void 0),void 0===e?Array:e},rr=function(t,e){return new(er(t))(0===e?0:e)},nr=Gt,ir=b,or=K,ar=Ce,ur=rr,sr=[].push,cr=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,u=5==t||o;return function(s,c,l,f){for(var h,p,v=or(s),d=ir(v),y=nr(c,l,3),g=ar(d.length),m=0,b=f||ur,_=e?b(s,g):r||a?b(s,0):void 0;g>m;m++)if((u||m in d)&&(p=y(h=d[m],m,v),t))if(e)_[m]=p;else if(p)switch(t){case 3:return!0;case 5:return h;case 6:return m;case 2:sr.call(_,h)}else switch(t){case 4:return!1;case 7:sr.call(_,h)}return o?-1:n||i?i:_}},lr={forEach:cr(0),map:cr(1),filter:cr(2),some:cr(3),every:cr(4),find:cr(5),findIndex:cr(6),filterReject:cr(7)},fr=a,hr=R,pr=pt("species"),vr=function(t){return hr>=51||!fr((function(){var e=[];return(e.constructor={})[pr]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},dr=lr.filter;fe({target:"Array",proto:!0,forced:!vr("filter")},{filter:function(t){return dr(this,t,arguments.length>1?arguments[1]:void 0)}});var yr=Te("Array").filter,gr=Array.prototype,mr=function(t){var e=t.filter;return t===gr||t instanceof Array&&e===gr.filter?yr:e},br=lr.map;fe({target:"Array",proto:!0,forced:!vr("map")},{map:function(t){return br(this,t,arguments.length>1?arguments[1]:void 0)}});var _r=Te("Array").map,wr=Array.prototype,Or=function(t){var e=t.map;return t===wr||t instanceof Array&&e===wr.map?_r:e},Er=Ke,xr=Ce,Tr=Gt,kr=function(t,e,r,n,i,o,a,u){for(var s,c=i,l=0,f=!!a&&Tr(a,u,3);l<n;){if(l in r){if(s=f?f(r[l],l,e):r[l],o>0&&Er(s))c=kr(t,e,s,xr(s.length),c,o-1)-1;else{if(c>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[c]=s}c++}l++}return c},Ar=kr,Sr=K,jr=Ce,Ir=Wt,Pr=rr;fe({target:"Array",proto:!0},{flatMap:function(t){var e,r=Sr(this),n=jr(r.length);return Ir(t),(e=Pr(r,0)).length=Ar(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var Dr=Te("Array").flatMap,Lr=Array.prototype,Cr=function(t){var e=t.flatMap;return t===Lr||t instanceof Array&&e===Lr.flatMap?Dr:e};function Mr(t){return new Rr(t)}var Nr=function(){function e(r,n,i){var o,a,u;t(this,e),this._source=r,this._transformers=n,this._target=i,this._listeners={add:Se(o=this._add).call(o,this),remove:Se(a=this._remove).call(a,this),update:Se(u=this._update).call(u,this)}}return ge(e,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return Be(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),e}(),Rr=function(){function e(r){t(this,e),this._source=r,this._transformers=[]}return ge(e,[{key:"filter",value:function(t){return this._transformers.push((function(e){return mr(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Or(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return Cr(e).call(e,t)})),this}},{key:"to",value:function(t){return new Nr(this._source,this._transformers,t)}}]),e}(),Fr=W,zr=function(t){if(Fr(t))throw TypeError("Cannot convert a Symbol value to a string");return String(t)},qr=Pe,Yr=zr,Xr=_,Wr=function(t){return function(e,r){var n,i,o=Yr(Xr(e)),a=qr(r),u=o.length;return a<0||a>=u?t?"":void 0:(n=o.charCodeAt(a))<55296||n>56319||a+1===u||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):n:t?o.slice(a,a+2):i-56320+(n-55296<<10)+65536}},Ur={codeAt:Wr(!1),charAt:Wr(!0)},Gr=$,Vr=Function.toString;"function"!=typeof Gr.inspectSource&&(Gr.inspectSource=function(t){return Vr.call(t)});var Hr,$r,Br,Jr=Gr.inspectSource,Kr=i.WeakMap,Qr="function"==typeof Kr&&/native code/.test(Jr(Kr)),Zr=G.exports,tn=nt,en=Zr("keys"),rn=function(t){return en[t]||(en[t]=tn(t))},nn={},on=Qr,an=x,un=re,sn=tt,cn=$,ln=rn,fn=nn,hn=i.WeakMap;if(on||cn.state){var pn=cn.state||(cn.state=new hn),vn=pn.get,dn=pn.has,yn=pn.set;Hr=function(t,e){if(dn.call(pn,t))throw new TypeError("Object already initialized");return e.facade=t,yn.call(pn,t,e),e},$r=function(t){return vn.call(pn,t)||{}},Br=function(t){return dn.call(pn,t)}}else{var gn=ln("state");fn[gn]=!0,Hr=function(t,e){if(sn(t,gn))throw new TypeError("Object already initialized");return e.facade=t,un(t,gn,e),e},$r=function(t){return sn(t,gn)?t[gn]:{}},Br=function(t){return sn(t,gn)}}var mn,bn,_n,wn={set:Hr,get:$r,has:Br,enforce:function(t){return Br(t)?$r(t):Hr(t,{})},getterFor:function(t){return function(e){var r;if(!an(e)||(r=$r(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},On=!a((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),En=tt,xn=K,Tn=On,kn=rn("IE_PROTO"),An=Object.prototype,Sn=Tn?Object.getPrototypeOf:function(t){return t=xn(t),En(t,kn)?t[kn]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?An:null},jn=a,In=Sn,Pn=re,Dn=tt,Ln=pt("iterator"),Cn=!1;[].keys&&("next"in(_n=[].keys())?(bn=In(In(_n)))!==Object.prototype&&(mn=bn):Cn=!0);var Mn=null==mn||jn((function(){var t={};return mn[Ln].call(t)!==t}));Mn&&(mn={}),Mn&&!Dn(mn,Ln)&&Pn(mn,Ln,(function(){return this}));var Nn,Rn={IteratorPrototype:mn,BUGGY_SAFARI_ITERATORS:Cn},Fn=Pe,zn=Math.max,qn=Math.min,Yn=function(t,e){var r=Fn(t);return r<0?zn(r+e,0):qn(r,e)},Xn=E,Wn=Ce,Un=Yn,Gn=function(t){return function(e,r,n){var i,o=Xn(e),a=Wn(o.length),u=Un(n,a);if(t&&r!=r){for(;a>u;)if((i=o[u++])!=i)return!0}else for(;a>u;u++)if((t||u in o)&&o[u]===r)return t||u||0;return!t&&-1}},Vn={includes:Gn(!0),indexOf:Gn(!1)},Hn=tt,$n=E,Bn=Vn.indexOf,Jn=nn,Kn=function(t,e){var r,n=$n(t),i=0,o=[];for(r in n)!Hn(Jn,r)&&Hn(n,r)&&o.push(r);for(;e.length>i;)Hn(n,r=e[i++])&&(~Bn(o,r)||o.push(r));return o},Qn=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Zn=Kn,ti=Qn,ei=Object.keys||function(t){return Zn(t,ti)},ri=Vt,ni=$t,ii=ei,oi=u?Object.defineProperties:function(t,e){ni(t);for(var r,n=ii(e),i=n.length,o=0;i>o;)ri.f(t,r=n[o++],e[r]);return t},ai=j("document","documentElement"),ui=$t,si=oi,ci=Qn,li=nn,fi=ai,hi=xt,pi=rn("IE_PROTO"),vi=function(){},di=function(t){return"<script>"+t+"<\/script>"},yi=function(t){t.write(di("")),t.close();var e=t.parentWindow.Object;return t=null,e},gi=function(){try{Nn=new ActiveXObject("htmlfile")}catch(t){}gi=document.domain&&Nn?yi(Nn):function(){var t,e=hi("iframe");if(e.style)return e.style.display="none",fi.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(di("document.F=Object")),t.close(),t.F}()||yi(Nn);for(var t=ci.length;t--;)delete gi.prototype[ci[t]];return gi()};li[pi]=!0;var mi=Object.create||function(t,e){var r;return null!==t?(vi.prototype=ui(t),r=new vi,vi.prototype=null,r[pi]=t):r=gi(),void 0===e?r:si(r,e)},bi={};bi[pt("toStringTag")]="z";var _i="[object z]"===String(bi),wi=_i,Oi=y,Ei=pt("toStringTag"),xi="Arguments"==Oi(function(){return arguments}()),Ti=wi?Oi:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),Ei))?r:xi?Oi(e):"Object"==(n=Oi(e))&&"function"==typeof e.callee?"Arguments":n},ki=Ti,Ai=_i?{}.toString:function(){return"[object "+ki(this)+"]"},Si=_i,ji=Vt.f,Ii=re,Pi=tt,Di=Ai,Li=pt("toStringTag"),Ci=function(t,e,r,n){if(t){var i=r?t:t.prototype;Pi(i,Li)||ji(i,Li,{configurable:!0,value:e}),n&&!Si&&Ii(i,"toString",Di)}},Mi={},Ni=Rn.IteratorPrototype,Ri=mi,Fi=v,zi=Ci,qi=Mi,Yi=function(){return this},Xi=x,Wi=$t,Ui=function(t){if(!Xi(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype");return t},Gi=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return Wi(r),Ui(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),Vi=re,Hi=function(t,e,r,n){n&&n.enumerable?t[e]=r:Vi(t,e,r)},$i=fe,Bi=function(t,e,r){var n=e+" Iterator";return t.prototype=Ri(Ni,{next:Fi(1,r)}),zi(t,n,!1,!0),qi[n]=Yi,t},Ji=Sn,Ki=Ci,Qi=re,Zi=Hi,to=Mi,eo=Rn.IteratorPrototype,ro=Rn.BUGGY_SAFARI_ITERATORS,no=pt("iterator"),io=function(){return this},oo=function(t,e,r,n,i,o,a){Bi(r,e,n);var u,s,c,l=function(t){if(t===i&&d)return d;if(!ro&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new r(this,t)}}return function(){return new r(this)}},f=e+" Iterator",h=!1,p=t.prototype,v=p[no]||p["@@iterator"]||i&&p[i],d=!ro&&v||l(i),y="Array"==e&&p.entries||v;if(y&&(u=Ji(y.call(new t)),eo!==Object.prototype&&u.next&&(Ki(u,f,!0,!0),to[f]=io)),"values"==i&&v&&"values"!==v.name&&(h=!0,d=function(){return v.call(this)}),a&&p[no]!==d&&Qi(p,no,d),to[e]=d,i)if(s={values:l("values"),keys:o?d:l("keys"),entries:l("entries")},a)for(c in s)(ro||h||!(c in p))&&Zi(p,c,s[c]);else $i({target:e,proto:!0,forced:ro||h},s);return s},ao=Ur.charAt,uo=zr,so=wn,co=oo,lo=so.set,fo=so.getterFor("String Iterator");co(String,"String",(function(t){lo(this,{type:"String Iterator",string:uo(t),index:0})}),(function(){var t,e=fo(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=ao(r,n),e.index+=t.length,{value:t,done:!1})}));var ho=$t,po=function(t){var e=t.return;if(void 0!==e)return ho(e.call(t)).value},vo=$t,yo=po,go=Mi,mo=pt("iterator"),bo=Array.prototype,_o=function(t){return void 0!==t&&(go.Array===t||bo[mo]===t)},wo=_t,Oo=Vt,Eo=v,xo=function(t,e,r){var n=wo(e);n in t?Oo.f(t,n,Eo(0,r)):t[n]=r},To=Ti,ko=Mi,Ao=pt("iterator"),So=function(t){if(null!=t)return t[Ao]||t["@@iterator"]||ko[To(t)]},jo=Gt,Io=K,Po=function(t,e,r,n){try{return n?e(vo(r)[0],r[1]):e(r)}catch(e){throw yo(t),e}},Do=_o,Lo=Ce,Co=xo,Mo=So,No=pt("iterator"),Ro=!1;try{var Fo=0,zo={next:function(){return{done:!!Fo++}},return:function(){Ro=!0}};zo[No]=function(){return this},Array.from(zo,(function(){throw 2}))}catch(t){}var qo=function(t){var e,r,n,i,o,a,u=Io(t),s="function"==typeof this?this:Array,c=arguments.length,l=c>1?arguments[1]:void 0,f=void 0!==l,h=Mo(u),p=0;if(f&&(l=jo(l,c>2?arguments[2]:void 0,2)),null==h||s==Array&&Do(h))for(r=new s(e=Lo(u.length));e>p;p++)a=f?l(u[p],p):u[p],Co(r,p,a);else for(o=(i=h.call(u)).next,r=new s;!(n=o.call(i)).done;p++)a=f?Po(i,l,[n.value,p],!0):n.value,Co(r,p,a);return r.length=p,r};fe({target:"Array",stat:!0,forced:!function(t,e){if(!e&&!Ro)return!1;var r=!1;try{var n={};n[No]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}))},{from:qo});var Yo=T.Array.from,Xo=Yo,Wo=E,Uo=Mi,Go=wn,Vo=oo,Ho=Go.set,$o=Go.getterFor("Array Iterator");Vo(Array,"Array",(function(t,e){Ho(this,{type:"Array Iterator",target:Wo(t),index:0,kind:e})}),(function(){var t=$o(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values"),Uo.Arguments=Uo.Array;var Bo=So,Jo={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},Ko=i,Qo=Ti,Zo=re,ta=Mi,ea=pt("toStringTag");for(var ra in Jo){var na=Ko[ra],ia=na&&na.prototype;ia&&Qo(ia)!==ea&&Zo(ia,ea,ra),ta[ra]=ta.Array}var oa=Bo,aa={},ua=Kn,sa=Qn.concat("length","prototype");aa.f=Object.getOwnPropertyNames||function(t){return ua(t,sa)};var ca={},la=E,fa=aa.f,ha={}.toString,pa="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];ca.f=function(t){return pa&&"[object Window]"==ha.call(t)?function(t){try{return fa(t)}catch(t){return pa.slice()}}(t):fa(la(t))};var va={};va.f=Object.getOwnPropertySymbols;var da={},ya=pt;da.f=ya;var ga=T,ma=tt,ba=da,_a=Vt.f,wa=function(t){var e=ga.Symbol||(ga.Symbol={});ma(e,t)||_a(e,t,{value:ba.f(t)})},Oa=fe,Ea=i,xa=j,Ta=u,ka=q,Aa=a,Sa=tt,ja=Ke,Ia=x,Pa=W,Da=$t,La=K,Ca=E,Ma=_t,Na=zr,Ra=v,Fa=mi,za=ei,qa=aa,Ya=ca,Xa=va,Wa=o,Ua=Vt,Ga=s,Va=re,Ha=Hi,$a=G.exports,Ba=nn,Ja=nt,Ka=pt,Qa=da,Za=wa,tu=Ci,eu=wn,ru=lr.forEach,nu=rn("hidden"),iu=Ka("toPrimitive"),ou=eu.set,au=eu.getterFor("Symbol"),uu=Object.prototype,su=Ea.Symbol,cu=xa("JSON","stringify"),lu=Wa.f,fu=Ua.f,hu=Ya.f,pu=Ga.f,vu=$a("symbols"),du=$a("op-symbols"),yu=$a("string-to-symbol-registry"),gu=$a("symbol-to-string-registry"),mu=$a("wks"),bu=Ea.QObject,_u=!bu||!bu.prototype||!bu.prototype.findChild,wu=Ta&&Aa((function(){return 7!=Fa(fu({},"a",{get:function(){return fu(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=lu(uu,e);n&&delete uu[e],fu(t,e,r),n&&t!==uu&&fu(uu,e,n)}:fu,Ou=function(t,e){var r=vu[t]=Fa(su.prototype);return ou(r,{type:"Symbol",tag:t,description:e}),Ta||(r.description=e),r},Eu=function(t,e,r){t===uu&&Eu(du,e,r),Da(t);var n=Ma(e);return Da(r),Sa(vu,n)?(r.enumerable?(Sa(t,nu)&&t[nu][n]&&(t[nu][n]=!1),r=Fa(r,{enumerable:Ra(0,!1)})):(Sa(t,nu)||fu(t,nu,Ra(1,{})),t[nu][n]=!0),wu(t,n,r)):fu(t,n,r)},xu=function(t,e){Da(t);var r=Ca(e),n=za(r).concat(Su(r));return ru(n,(function(e){Ta&&!Tu.call(r,e)||Eu(t,e,r[e])})),t},Tu=function(t){var e=Ma(t),r=pu.call(this,e);return!(this===uu&&Sa(vu,e)&&!Sa(du,e))&&(!(r||!Sa(this,e)||!Sa(vu,e)||Sa(this,nu)&&this[nu][e])||r)},ku=function(t,e){var r=Ca(t),n=Ma(e);if(r!==uu||!Sa(vu,n)||Sa(du,n)){var i=lu(r,n);return!i||!Sa(vu,n)||Sa(r,nu)&&r[nu][n]||(i.enumerable=!0),i}},Au=function(t){var e=hu(Ca(t)),r=[];return ru(e,(function(t){Sa(vu,t)||Sa(Ba,t)||r.push(t)})),r},Su=function(t){var e=t===uu,r=hu(e?du:Ca(t)),n=[];return ru(r,(function(t){!Sa(vu,t)||e&&!Sa(uu,t)||n.push(vu[t])})),n};(ka||(Ha((su=function(){if(this instanceof su)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?Na(arguments[0]):void 0,e=Ja(t),r=function(t){this===uu&&r.call(du,t),Sa(this,nu)&&Sa(this[nu],e)&&(this[nu][e]=!1),wu(this,e,Ra(1,t))};return Ta&&_u&&wu(uu,e,{configurable:!0,set:r}),Ou(e,t)}).prototype,"toString",(function(){return au(this).tag})),Ha(su,"withoutSetter",(function(t){return Ou(Ja(t),t)})),Ga.f=Tu,Ua.f=Eu,Wa.f=ku,qa.f=Ya.f=Au,Xa.f=Su,Qa.f=function(t){return Ou(Ka(t),t)},Ta&&fu(su.prototype,"description",{configurable:!0,get:function(){return au(this).description}})),Oa({global:!0,wrap:!0,forced:!ka,sham:!ka},{Symbol:su}),ru(za(mu),(function(t){Za(t)})),Oa({target:"Symbol",stat:!0,forced:!ka},{for:function(t){var e=Na(t);if(Sa(yu,e))return yu[e];var r=su(e);return yu[e]=r,gu[r]=e,r},keyFor:function(t){if(!Pa(t))throw TypeError(t+" is not a symbol");if(Sa(gu,t))return gu[t]},useSetter:function(){_u=!0},useSimple:function(){_u=!1}}),Oa({target:"Object",stat:!0,forced:!ka,sham:!Ta},{create:function(t,e){return void 0===e?Fa(t):xu(Fa(t),e)},defineProperty:Eu,defineProperties:xu,getOwnPropertyDescriptor:ku}),Oa({target:"Object",stat:!0,forced:!ka},{getOwnPropertyNames:Au,getOwnPropertySymbols:Su}),Oa({target:"Object",stat:!0,forced:Aa((function(){Xa.f(1)}))},{getOwnPropertySymbols:function(t){return Xa.f(La(t))}}),cu)&&Oa({target:"JSON",stat:!0,forced:!ka||Aa((function(){var t=su();return"[null]"!=cu([t])||"{}"!=cu({a:t})||"{}"!=cu(Object(t))}))},{stringify:function(t,e,r){for(var n,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(n=e,(Ia(e)||void 0!==t)&&!Pa(t))return ja(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Pa(e))return e}),i[1]=e,cu.apply(null,i)}});su.prototype[iu]||Va(su.prototype,iu,su.prototype.valueOf),tu(su,"Symbol"),Ba[nu]=!0;var ju=T.Object.getOwnPropertySymbols,Iu={exports:{}},Pu=fe,Du=a,Lu=E,Cu=o.f,Mu=u,Nu=Du((function(){Cu(1)}));Pu({target:"Object",stat:!0,forced:!Mu||Nu,sham:!Mu},{getOwnPropertyDescriptor:function(t,e){return Cu(Lu(t),e)}});var Ru=T.Object,Fu=Iu.exports=function(t,e){return Ru.getOwnPropertyDescriptor(t,e)};Ru.getOwnPropertyDescriptor.sham&&(Fu.sham=!0);var zu=Iu.exports,qu=aa,Yu=va,Xu=$t,Wu=j("Reflect","ownKeys")||function(t){var e=qu.f(Xu(t)),r=Yu.f;return r?e.concat(r(t)):e},Uu=Wu,Gu=E,Vu=o,Hu=xo;fe({target:"Object",stat:!0,sham:!u},{getOwnPropertyDescriptors:function(t){for(var e,r,n=Gu(t),i=Vu.f,o=Uu(n),a={},u=0;o.length>u;)void 0!==(r=i(n,e=o[u++]))&&Hu(a,e,r);return a}});var $u=T.Object.getOwnPropertyDescriptors,Bu={exports:{}};fe({target:"Object",stat:!0,forced:!u,sham:!u},{defineProperties:oi});var Ju=T.Object,Ku=Bu.exports=function(t,e){return Ju.defineProperties(t,e)};Ju.defineProperties.sham&&(Ku.sham=!0);var Qu=Bu.exports,Zu=ve;function ts(t,e,r){return e in t?de(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}fe({target:"Array",stat:!0},{isArray:Ke});var es=T.Array.isArray,rs=es;var ns=fe,is=a,os=Ke,as=x,us=K,ss=Ce,cs=xo,ls=rr,fs=vr,hs=R,ps=pt("isConcatSpreadable"),vs=hs>=51||!is((function(){var t=[];return t[ps]=!1,t.concat()[0]!==t})),ds=fs("concat"),ys=function(t){if(!as(t))return!1;var e=t[ps];return void 0!==e?!!e:os(t)};ns({target:"Array",proto:!0,forced:!vs||!ds},{concat:function(t){var e,r,n,i,o,a=us(this),u=ls(a,0),s=0;for(e=-1,n=arguments.length;e<n;e++)if(ys(o=-1===e?a:arguments[e])){if(s+(i=ss(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(r=0;r<i;r++,s++)r in o&&cs(u,s,o[r])}else{if(s>=9007199254740991)throw TypeError("Maximum allowed index exceeded");cs(u,s++,o)}return u.length=s,u}}),wa("asyncIterator"),wa("hasInstance"),wa("isConcatSpreadable"),wa("iterator"),wa("match"),wa("matchAll"),wa("replace"),wa("search"),wa("species"),wa("split"),wa("toPrimitive"),wa("toStringTag"),wa("unscopables"),Ci(i.JSON,"JSON",!0);var gs=T.Symbol;wa("asyncDispose"),wa("dispose"),wa("matcher"),wa("metadata"),wa("observable"),wa("patternMatch"),wa("replaceAll");var ms=gs;var bs=fe,_s=x,ws=Ke,Os=Yn,Es=Ce,xs=E,Ts=xo,ks=pt,As=vr("slice"),Ss=ks("species"),js=[].slice,Is=Math.max;bs({target:"Array",proto:!0,forced:!As},{slice:function(t,e){var r,n,i,o=xs(this),a=Es(o.length),u=Os(t,a),s=Os(void 0===e?a:e,a);if(ws(o)&&("function"!=typeof(r=o.constructor)||r!==Array&&!ws(r.prototype)?_s(r)&&null===(r=r[Ss])&&(r=void 0):r=void 0,r===Array||void 0===r))return js.call(o,u,s);for(n=new(void 0===r?Array:r)(Is(s-u,0)),i=0;u<s;u++,i++)u in o&&Ts(n,i,o[u]);return n.length=i,n}});var Ps=Te("Array").slice,Ds=Array.prototype,Ls=function(t){var e=t.slice;return t===Ds||t instanceof Array&&e===Ds.slice?Ps:e},Cs=Ls,Ms=Yo;function Ns(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Rs(t,e){var r;if(t){if("string"==typeof t)return Ns(t,e);var n=Cs(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Ms(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Ns(t,e):void 0}}function Fs(t,e){return function(t){if(rs(t))return t}(t)||function(t,e){var r=null==t?null:void 0!==ms&&oa(t)||t["@@iterator"];if(null!=r){var n,i,o=[],a=!0,u=!1;try{for(r=r.call(t);!(a=(n=r.next()).done)&&(o.push(n.value),!e||o.length!==e);a=!0);}catch(t){u=!0,i=t}finally{try{a||null==r.return||r.return()}finally{if(u)throw i}}return o}}(t,e)||Rs(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var zs=da.f("iterator"),qs=zs;function Ys(t){return(Ys="function"==typeof ms&&"symbol"==typeof qs?function(t){return typeof t}:function(t){return t&&"function"==typeof ms&&t.constructor===ms&&t!==ms.prototype?"symbol":typeof t})(t)}function Xs(t){return function(t){if(rs(t))return Ns(t)}(t)||function(t){if(void 0!==ms&&null!=oa(t)||null!=t["@@iterator"])return Ms(t)}(t)||Rs(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ws=gs,Us=Te("Array").concat,Gs=Array.prototype,Vs=function(t){var e=t.concat;return t===Gs||t instanceof Array&&e===Gs.concat?Us:e},Hs=Ls;fe({target:"Reflect",stat:!0},{ownKeys:Wu});var $s=T.Reflect.ownKeys,Bs=es,Js=K,Ks=ei;fe({target:"Object",stat:!0,forced:a((function(){Ks(1)}))},{keys:function(t){return Ks(Js(t))}});var Qs=T.Object.keys;fe({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}}),T.Date.now;var Zs=lr.forEach,tc=Xe("forEach")?[].forEach:function(t){return Zs(this,t,arguments.length>1?arguments[1]:void 0)};fe({target:"Array",proto:!0,forced:[].forEach!=tc},{forEach:tc});var ec=Te("Array").forEach,rc=Ti,nc=Array.prototype,ic={DOMTokenList:!0,NodeList:!0},oc=function(t){var e=t.forEach;return t===nc||t instanceof Array&&e===nc.forEach||ic.hasOwnProperty(rc(t))?ec:e},ac=Ke,uc=[].reverse,sc=[1,2];fe({target:"Array",proto:!0,forced:String(sc)===String(sc.reverse())},{reverse:function(){return ac(this)&&(this.length=this.length),uc.call(this)}});var cc=Te("Array").reverse,lc=Array.prototype,fc=function(t){var e=t.reverse;return t===lc||t instanceof Array&&e===lc.reverse?cc:e},hc=fe,pc=Yn,vc=Pe,dc=Ce,yc=K,gc=rr,mc=xo,bc=vr("splice"),_c=Math.max,wc=Math.min;hc({target:"Array",proto:!0,forced:!bc},{splice:function(t,e){var r,n,i,o,a,u,s=yc(this),c=dc(s.length),l=pc(t,c),f=arguments.length;if(0===f?r=n=0:1===f?(r=0,n=c-l):(r=f-2,n=wc(_c(vc(e),0),c-l)),c+r-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(i=gc(s,n),o=0;o<n;o++)(a=l+o)in s&&mc(i,o,s[a]);if(i.length=n,r<n){for(o=l;o<c-n;o++)u=o+r,(a=o+n)in s?s[u]=s[a]:delete s[u];for(o=c;o>c-n+r;o--)delete s[o-1]}else if(r>n)for(o=c-n;o>l;o--)u=o+r-1,(a=o+n-1)in s?s[u]=s[a]:delete s[u];for(o=0;o<r;o++)s[o+l]=arguments[o+2];return s.length=c-n+r,i}});var Oc=Te("Array").splice,Ec=Array.prototype,xc=function(t){var e=t.splice;return t===Ec||t instanceof Array&&e===Ec.splice?Oc:e},Tc=u,kc=a,Ac=ei,Sc=va,jc=s,Ic=K,Pc=b,Dc=Object.assign,Lc=Object.defineProperty,Cc=!Dc||kc((function(){if(Tc&&1!==Dc({b:1},Dc(Lc({},"a",{enumerable:!0,get:function(){Lc(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Dc({},t)[r]||Ac(Dc({},e)).join("")!=n}))?function(t,e){for(var r=Ic(t),n=arguments.length,i=1,o=Sc.f,a=jc.f;n>i;)for(var u,s=Pc(arguments[i++]),c=o?Ac(s).concat(o(s)):Ac(s),l=c.length,f=0;l>f;)u=c[f++],Tc&&!a.call(s,u)||(r[u]=s[u]);return r}:Dc;fe({target:"Object",stat:!0,forced:Object.assign!==Cc},{assign:Cc});var Mc=T.Object.assign,Nc=Vn.includes;fe({target:"Array",proto:!0},{includes:function(t){return Nc(this,t,arguments.length>1?arguments[1]:void 0)}}),Te("Array").includes;var Rc=x,Fc=y,zc=pt("match"),qc=function(t){var e;return Rc(t)&&(void 0!==(e=t[zc])?!!e:"RegExp"==Fc(t))},Yc=pt("match"),Xc=function(t){if(qc(t))throw TypeError("The method doesn't accept regular expressions");return t},Wc=_,Uc=zr;fe({target:"String",proto:!0,forced:!function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[Yc]=!1,"/./"[t](e)}catch(t){}}return!1}("includes")},{includes:function(t){return!!~Uc(Wc(this)).indexOf(Uc(Xc(t)),arguments.length>1?arguments[1]:void 0)}}),Te("String").includes;var Gc=K,Vc=Sn,Hc=On;fe({target:"Object",stat:!0,forced:a((function(){Vc(1)})),sham:!Hc},{getPrototypeOf:function(t){return Vc(Gc(t))}});var $c=T.Object.getPrototypeOf,Bc=u,Jc=ei,Kc=E,Qc=s.f,Zc=function(t){return function(e){for(var r,n=Kc(e),i=Jc(n),o=i.length,a=0,u=[];o>a;)r=i[a++],Bc&&!Qc.call(n,r)||u.push(t?[r,n[r]]:n[r]);return u}},tl={entries:Zc(!0),values:Zc(!1)}.values;fe({target:"Object",stat:!0},{values:function(t){return tl(t)}}),T.Object.values;var el=_,rl=zr,nl="[\t\n\v\f\r                　\u2028\u2029\ufeff]",il=RegExp("^"+nl+nl+"*"),ol=RegExp(nl+nl+"*$"),al=function(t){return function(e){var r=rl(el(e));return 1&t&&(r=r.replace(il,"")),2&t&&(r=r.replace(ol,"")),r}},ul={start:al(1),end:al(2),trim:al(3)},sl=zr,cl=ul.trim,ll=i.parseInt,fl=/^[+-]?0[Xx]/,hl=8!==ll("\t\n\v\f\r                　\u2028\u2029\ufeff08")||22!==ll("\t\n\v\f\r                　\u2028\u2029\ufeff0x16")?function(t,e){var r=cl(sl(t));return ll(r,e>>>0||(fl.test(r)?16:10))}:ll;fe({global:!0,forced:parseInt!=hl},{parseInt:hl});var pl=fe,vl=Vn.indexOf,dl=Xe,yl=[].indexOf,gl=!!yl&&1/[1].indexOf(1,-0)<0,ml=dl("indexOf");pl({target:"Array",proto:!0,forced:gl||!ml},{indexOf:function(t){return gl?yl.apply(this,arguments)||0:vl(this,t,arguments.length>1?arguments[1]:void 0)}}),Te("Array").indexOf;var bl=a,_l="\t\n\v\f\r                　\u2028\u2029\ufeff",wl=ul.trim;fe({target:"String",proto:!0,forced:function(t){return bl((function(){return!!_l[t]()||"​᠎"!="​᠎"[t]()||_l[t].name!==t}))}("trim")},{trim:function(){return wl(this)}}),Te("String").trim,fe({target:"Object",stat:!0,sham:!u},{create:mi});var Ol=T.Object,El=function(t,e){return Ol.create(t,e)},xl=El,Tl=fe,kl=a,Al=j("JSON","stringify"),Sl=/[\uD800-\uDFFF]/g,jl=/^[\uD800-\uDBFF]$/,Il=/^[\uDC00-\uDFFF]$/,Pl=function(t,e,r){var n=r.charAt(e-1),i=r.charAt(e+1);return jl.test(t)&&!Il.test(i)||Il.test(t)&&!jl.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},Dl=kl((function(){return'"\\udf06\\ud834"'!==Al("\udf06\ud834")||'"\\udead"'!==Al("\udead")}));Al&&Tl({target:"JSON",stat:!0,forced:Dl},{stringify:function(t,e,r){var n=Al.apply(null,arguments);return"string"==typeof n?n.replace(Sl,Pl):n}});var Ll=T;Ll.JSON||(Ll.JSON={stringify:JSON.stringify});var Cl=function(t,e,r){return Ll.JSON.stringify.apply(null,arguments)},Ml=i,Nl=[].slice,Rl=function(t){return function(e,r){var n=arguments.length>2,i=n?Nl.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,r)}};fe({global:!0,bind:!0,forced:/MSIE .\./.test(I)},{setTimeout:Rl(Ml.setTimeout),setInterval:Rl(Ml.setInterval)});var Fl=T.setTimeout,zl=K,ql=Yn,Yl=Ce;fe({target:"Array",proto:!0},{fill:function(t){for(var e=zl(this),r=Yl(e.length),n=arguments.length,i=ql(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:ql(o,r);a>i;)e[i++]=t;return e}}),Te("Array").fill;var Xl={exports:{}};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}Xl.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}();var Wl=Xl.exports;
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */function Ul(){return(Ul=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t}).apply(this,arguments)}function Gl(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function Vl(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var Hl,$l="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign,Bl=["","webkit","Moz","MS","ms","o"],Jl="undefined"==typeof document?{style:{}}:document.createElement("div"),Kl=Math.round,Ql=Math.abs,Zl=Date.now;function tf(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<Bl.length;){if((n=(r=Bl[o])?r+i:e)in t)return n;o++}}Hl="undefined"==typeof window?{}:window;var ef=tf(Jl.style,"touchAction"),rf=void 0!==ef;var nf=function(){if(!rf)return!1;var t={},e=Hl.CSS&&Hl.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||Hl.CSS.supports("touch-action",r)})),t}(),of="ontouchstart"in Hl,af=void 0!==tf(Hl,"PointerEvent"),uf=of&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),sf=["x","y"],cf=["clientX","clientY"];function lf(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function ff(t,e){return"function"==typeof t?t.apply(e&&e[0]||void 0,e):t}function hf(t,e){return t.indexOf(e)>-1}var pf=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){"compute"===t&&(t=this.compute()),rf&&this.manager.element.style&&nf[t]&&(this.manager.element.style[ef]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return lf(this.manager.recognizers,(function(e){ff(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(hf(t,"none"))return"none";var e=hf(t,"pan-x"),r=hf(t,"pan-y");return e&&r?"none":e||r?e?"pan-x":"pan-y":hf(t,"manipulation")?"manipulation":"auto"}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=hf(n,"none")&&!nf.none,o=hf(n,"pan-y")&&!nf["pan-y"],a=hf(n,"pan-x")&&!nf["pan-x"];if(i){var u=1===t.pointers.length,s=t.distance<2,c=t.deltaTime<250;if(u&&s&&c)return}if(!a||!o)return i||o&&6&r||a&&24&r?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function vf(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function df(t){var e=t.length;if(1===e)return{x:Kl(t[0].clientX),y:Kl(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:Kl(r/e),y:Kl(n/e)}}function yf(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:Kl(t.pointers[r].clientX),clientY:Kl(t.pointers[r].clientY)},r++;return{timeStamp:Zl(),pointers:e,center:df(e),deltaX:t.deltaX,deltaY:t.deltaY}}function gf(t,e,r){r||(r=sf);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function mf(t,e,r){r||(r=sf);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function bf(t,e){return t===e?1:Ql(t)>=Ql(e)?t<0?2:4:e<0?8:16}function _f(t,e,r){return{x:e/t||0,y:r/t||0}}function wf(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=yf(e)),i>1&&!r.firstMultiple?r.firstMultiple=yf(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,u=a?a.center:o.center,s=e.center=df(n);e.timeStamp=Zl(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=mf(u,s),e.distance=gf(u,s),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};1!==e.eventType&&4!==o.eventType||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=bf(e.deltaX,e.deltaY);var c,l,f=_f(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=f.x,e.overallVelocityY=f.y,e.overallVelocity=Ql(f.x)>Ql(f.y)?f.x:f.y,e.scale=a?(c=a.pointers,gf((l=n)[0],l[1],cf)/gf(c[0],c[1],cf)):1,e.rotation=a?function(t,e){return mf(e[1],e[0],cf)+mf(t[1],t[0],cf)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,u=e.timeStamp-a.timeStamp;if(8!==e.eventType&&(u>25||void 0===a.velocity)){var s=e.deltaX-a.deltaX,c=e.deltaY-a.deltaY,l=_f(u,s,c);n=l.x,i=l.y,r=Ql(l.x)>Ql(l.y)?l.x:l.y,o=bf(s,c),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var h,p=t.element,v=e.srcEvent;vf(h=v.composedPath?v.composedPath()[0]:v.path?v.path[0]:v.target,p)&&(p=h),e.target=p}function Of(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=1&e&&n-i==0,a=12&e&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,wf(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function Ef(t){return t.trim().split(/\s+/g)}function xf(t,e,r){lf(Ef(e),(function(e){t.addEventListener(e,r,!1)}))}function Tf(t,e,r){lf(Ef(e),(function(e){t.removeEventListener(e,r,!1)}))}function kf(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var Af=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){ff(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&xf(this.element,this.evEl,this.domHandler),this.evTarget&&xf(this.target,this.evTarget,this.domHandler),this.evWin&&xf(kf(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&Tf(this.element,this.evEl,this.domHandler),this.evTarget&&Tf(this.target,this.evTarget,this.domHandler),this.evWin&&Tf(kf(this.element),this.evWin,this.domHandler)},t}();function Sf(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var jf={pointerdown:1,pointermove:2,pointerup:4,pointercancel:8,pointerout:8},If={2:"touch",3:"pen",4:"mouse",5:"kinect"},Pf="pointerdown",Df="pointermove pointerup pointercancel";Hl.MSPointerEvent&&!Hl.PointerEvent&&(Pf="MSPointerDown",Df="MSPointerMove MSPointerUp MSPointerCancel");var Lf=function(t){function e(){var r,n=e.prototype;return n.evEl=Pf,n.evWin=Df,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return Gl(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=jf[n],o=If[t.pointerType]||t.pointerType,a="touch"===o,u=Sf(e,t.pointerId,"pointerId");1&i&&(0===t.button||a)?u<0&&(e.push(t),u=e.length-1):12&i&&(r=!0),u<0||(e[u]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(u,1))},e}(Af);function Cf(t){return Array.prototype.slice.call(t,0)}function Mf(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];Sf(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var Nf={touchstart:1,touchmove:2,touchend:4,touchcancel:8},Rf=function(t){function e(){var r;return e.prototype.evTarget="touchstart touchmove touchend touchcancel",(r=t.apply(this,arguments)||this).targetIds={},r}return Gl(e,t),e.prototype.handler=function(t){var e=Nf[t.type],r=Ff.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:"touch",srcEvent:t})},e}(Af);function Ff(t,e){var r,n,i=Cf(t.touches),o=this.targetIds;if(3&e&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=Cf(t.changedTouches),u=[],s=this.target;if(n=i.filter((function(t){return vf(t.target,s)})),1===e)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&u.push(a[r]),12&e&&delete o[a[r].identifier],r++;return u.length?[Mf(n.concat(u),"identifier",!0),u]:void 0}var zf={mousedown:1,mousemove:2,mouseup:4},qf=function(t){function e(){var r,n=e.prototype;return n.evEl="mousedown",n.evWin="mousemove mouseup",(r=t.apply(this,arguments)||this).pressed=!1,r}return Gl(e,t),e.prototype.handler=function(t){var e=zf[t.type];1&e&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=4),this.pressed&&(4&e&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:"mouse",srcEvent:t}))},e}(Af);function Yf(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),2500)}}function Xf(t,e){1&t?(this.primaryTouch=e.changedPointers[0].identifier,Yf.call(this,e)):12&t&&Yf.call(this,e)}function Wf(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=25&&a<=25)return!0}return!1}var Uf=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i="touch"===r.pointerType,o="mouse"===r.pointerType;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)Xf.call(Vl(Vl(n)),e,r);else if(o&&Wf.call(Vl(Vl(n)),r))return;n.callback(t,e,r)}},n.touch=new Rf(n.manager,n.handler),n.mouse=new qf(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Gl(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(Af)}();function Gf(t,e,r){return!!Array.isArray(t)&&(lf(t,r[e],r),!0)}var Vf=1;function Hf(t,e){var r=e.manager;return r?r.get(t):t}function $f(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}var Bf=function(){function t(t){void 0===t&&(t={}),this.options=Ul({enable:!0},t),this.id=Vf++,this.manager=null,this.state=1,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return $l(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Gf(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Hf(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Gf(t,"dropRecognizeWith",this)||(t=Hf(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(Gf(t,"requireFailure",this))return this;var e=this.requireFail;return-1===Sf(e,t=Hf(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Gf(t,"dropRequireFailure",this))return this;t=Hf(t,this);var e=Sf(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<8&&n(e.options.event+$f(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=8&&n(e.options.event+$f(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=32},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},e.recognize=function(t){var e=$l({},t);if(!ff(this.options.enable,[this,e]))return this.reset(),void(this.state=32);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Jf=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ul({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}Gl(e,t);var r=e.prototype;return r.getTouchAction=function(){return["manipulation"]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),1&t.eventType&&0===this.count)return this.failTimeout();if(i&&o&&n){if(4!==t.eventType)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,u=!this.pCenter||gf(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,u&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.interval),2):8}return 32},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=32}),this.options.interval),32},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){8===this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Bf),Kf=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ul({pointers:1},e))||this}Gl(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=6&e,i=this.attrTest(t);return n&&(8&r||!i)?16|e:n||i?4&r?8|e:2&e?4|e:2:32},e}(Bf);function Qf(t){return 16===t?"down":8===t?"up":2===t?"left":4===t?"right":""}var Zf=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ul({event:"pan",threshold:10,pointers:1,direction:30},e))||this).pX=null,r.pY=null,r}Gl(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return 6&t&&e.push("pan-y"),24&t&&e.push("pan-x"),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(6&e.direction?(i=0===o?1:o<0?2:4,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?1:a<0?8:16,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return Kf.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=Qf(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(Kf),th=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ul({event:"swipe",threshold:10,velocity:.3,direction:30,pointers:1},e))||this}Gl(e,t);var r=e.prototype;return r.getTouchAction=function(){return Zf.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return 30&n?r=e.overallVelocity:6&n?r=e.overallVelocityX:24&n&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&Ql(r)>this.options.velocity&&4&e.eventType},r.emit=function(t){var e=Qf(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Kf),eh=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ul({event:"pinch",threshold:0,pointers:2},e))||this}Gl(e,t);var r=e.prototype;return r.getTouchAction=function(){return["none"]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||2&this.state)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(Kf),rh=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ul({event:"rotate",threshold:0,pointers:2},e))||this}Gl(e,t);var r=e.prototype;return r.getTouchAction=function(){return["none"]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||2&this.state)},e}(Kf),nh=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Ul({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}Gl(e,t);var r=e.prototype;return r.getTouchAction=function(){return["auto"]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||12&t.eventType&&!o)this.reset();else if(1&t.eventType)this.reset(),this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.time);else if(4&t.eventType)return 8;return 32},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){8===this.state&&(t&&4&t.eventType?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=Zl(),this.manager.emit(this.options.event,this._input)))},e}(Bf),ih={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},oh=[[rh,{enable:!1}],[eh,{enable:!1},["rotate"]],[th,{direction:6}],[Zf,{direction:6},["swipe"]],[Jf],[Jf,{event:"doubletap",taps:2},["tap"]],[nh]];function ah(t,e){var r,n=t.element;n.style&&(lf(t.options.cssProps,(function(i,o){r=tf(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var uh=function(){function t(t,e){var r,n=this;this.options=$l({},ih,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(af?Lf:uf?Rf:of?Uf:qf))(r,Of),this.touchAction=new pf(this,this.options.touchAction),ah(this,!0),lf(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return $l(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&8&i.state)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&14&r.state&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof Bf)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(Gf(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Gf(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=Sf(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return lf(Ef(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return lf(Ef(t),(function(t){e?r[t]&&r[t].splice(Sf(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&ah(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),sh={touchstart:1,touchmove:2,touchend:4,touchcancel:8},ch=function(t){function e(){var r,n=e.prototype;return n.evTarget="touchstart",n.evWin="touchstart touchmove touchend touchcancel",(r=t.apply(this,arguments)||this).started=!1,r}return Gl(e,t),e.prototype.handler=function(t){var e=sh[t.type];if(1===e&&(this.started=!0),this.started){var r=lh.call(this,t,e);12&e&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:"touch",srcEvent:t})}},e}(Af);function lh(t,e){var r=Cf(t.touches),n=Cf(t.changedTouches);return 12&e&&(r=Mf(r.concat(n),"identifier",!0)),[r,n]}function fh(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var hh=fh((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),ph=fh((function(t,e){return hh(t,e,!0)}),"merge","Use `assign`.");function vh(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&$l(n,r)}function dh(t,e){return function(){return t.apply(e,arguments)}}var yh=function(){var t=function(t,e){return void 0===e&&(e={}),new uh(t,Ul({recognizers:oh.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=30,t.DIRECTION_DOWN=16,t.DIRECTION_LEFT=2,t.DIRECTION_RIGHT=4,t.DIRECTION_UP=8,t.DIRECTION_HORIZONTAL=6,t.DIRECTION_VERTICAL=24,t.DIRECTION_NONE=1,t.DIRECTION_DOWN=16,t.INPUT_START=1,t.INPUT_MOVE=2,t.INPUT_END=4,t.INPUT_CANCEL=8,t.STATE_POSSIBLE=1,t.STATE_BEGAN=2,t.STATE_CHANGED=4,t.STATE_ENDED=8,t.STATE_RECOGNIZED=8,t.STATE_CANCELLED=16,t.STATE_FAILED=32,t.Manager=uh,t.Input=Af,t.TouchAction=pf,t.TouchInput=Rf,t.MouseInput=qf,t.PointerEventInput=Lf,t.TouchMouseInput=Uf,t.SingleTouchInput=ch,t.Recognizer=Bf,t.AttrRecognizer=Kf,t.Tap=Jf,t.Pan=Zf,t.Swipe=th,t.Pinch=eh,t.Rotate=rh,t.Press=nh,t.on=xf,t.off=Tf,t.each=lf,t.merge=ph,t.extend=hh,t.bindFn=dh,t.assign=$l,t.inherit=vh,t.bindFn=dh,t.prefixed=tf,t.toArray=Cf,t.inArray=Sf,t.uniqueArray=Mf,t.splitStr=Ef,t.boolOrFn=ff,t.hasParent=vf,t.addEventListeners=xf,t.removeEventListeners=Tf,t.defaults=$l({},ih,{preset:oh}),t}();function gh(t,e){var r=void 0!==Ws&&oa(t)||t["@@iterator"];if(!r){if(Bs(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return mh(t,e);var n=Hs(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Xo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return mh(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function mh(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var bh=Ws("DELETE");function _h(){var t=wh.apply(void 0,arguments);return Eh(t),t}function wh(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return wh.apply(void 0,Vs(n=[_h(e[0],e[1])]).call(n,Xs(Hs(e).call(e,2))));var i,o=e[0],a=e[1],u=gh($s(a));try{for(u.s();!(i=u.n()).done;){var s=i.value;Object.prototype.propertyIsEnumerable.call(a,s)&&(a[s]===bh?delete o[s]:null===o[s]||null===a[s]||"object"!==Ys(o[s])||"object"!==Ys(a[s])||Bs(o[s])||Bs(a[s])?o[s]=Oh(a[s]):o[s]=wh(o[s],a[s]))}}catch(t){u.e(t)}finally{u.f()}return o}function Oh(t){return Bs(t)?Or(t).call(t,(function(t){return Oh(t)})):"object"===Ys(t)&&null!==t?wh({},t):t}function Eh(t){for(var e=0,r=Qs(t);e<r.length;e++){var n=r[e];t[n]===bh?delete t[n]:"object"===Ys(t[n])&&null!==t[n]&&Eh(t[n])}}var xh="undefined"!=typeof window?window.Hammer||yh:function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(){return{set:t}}};var t};function Th(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=xh(this._dom.overlay);n.on("tap",Se(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];oc(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}Wl(Th.prototype),Th.current=null,Th.prototype.destroy=function(){var t,e;this.deactivate();var r,n=gh(fc(t=xc(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},Th.prototype.activate=function(){Th.current&&Th.current.deactivate(),Th.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},Th.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},Th.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var kh=fe,Ah=Wt,Sh=$t,jh=x,Ih=mi,Ph=Ee,Dh=a,Lh=j("Reflect","construct"),Ch=Dh((function(){function t(){}return!(Lh((function(){}),[],t)instanceof t)})),Mh=!Dh((function(){Lh((function(){}))})),Nh=Ch||Mh;kh({target:"Reflect",stat:!0,forced:Nh,sham:Nh},{construct:function(t,e){Ah(t),Sh(e);var r=arguments.length<3?t:Ah(arguments[2]);if(Mh&&!Ch)return Lh(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(Ph.apply(t,n))}var i=r.prototype,o=Ih(jh(i)?i:Object.prototype),a=Function.apply.call(t,o,e);return jh(a)?a:o}});var Rh=T.Reflect.construct,Fh=El;fe({target:"Object",stat:!0},{setPrototypeOf:Gi});var zh=T.Object.setPrototypeOf;function qh(t,e){return(qh=zh||function(t,e){return t.__proto__=e,t})(t,e)}function Yh(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Fh(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&qh(t,e)}function Xh(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}function Wh(t,e){if(e&&("object"===Ys(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return Xh(t)}var Uh=$c;function Gh(t){return(Gh=zh?Uh:function(t){return t.__proto__||Uh(t)})(t)}var Vh={exports:{}};!function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,i="function"==typeof Symbol?Symbol:{},o=i.iterator||"@@iterator",a=i.asyncIterator||"@@asyncIterator",u=i.toStringTag||"@@toStringTag";function s(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{s({},"")}catch(t){s=function(t,e,r){return t[e]=r}}function c(t,e,r,n){var i=e&&e.prototype instanceof y?e:y,o=Object.create(i.prototype),a=new S(n||[]);return o._invoke=function(t,e,r){var n=f;return function(i,o){if(n===p)throw new Error("Generator is already running");if(n===v){if("throw"===i)throw o;return I()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var u=T(a,r);if(u){if(u===d)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===f)throw n=v,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=p;var s=l(t,e,r);if("normal"===s.type){if(n=r.done?v:h,s.arg===d)continue;return{value:s.arg,done:r.done}}"throw"===s.type&&(n=v,r.method="throw",r.arg=s.arg)}}}(t,r,a),o}function l(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=c;var f="suspendedStart",h="suspendedYield",p="executing",v="completed",d={};function y(){}function g(){}function m(){}var b={};b[o]=function(){return this};var _=Object.getPrototypeOf,w=_&&_(_(j([])));w&&w!==r&&n.call(w,o)&&(b=w);var O=m.prototype=y.prototype=Object.create(b);function E(t){["next","throw","return"].forEach((function(e){s(t,e,(function(t){return this._invoke(e,t)}))}))}function x(t,e){function r(i,o,a,u){var s=l(t[i],t,o);if("throw"!==s.type){var c=s.arg,f=c.value;return f&&"object"==typeof f&&n.call(f,"__await")?e.resolve(f.__await).then((function(t){r("next",t,a,u)}),(function(t){r("throw",t,a,u)})):e.resolve(f).then((function(t){c.value=t,a(c)}),(function(t){return r("throw",t,a,u)}))}u(s.arg)}var i;this._invoke=function(t,n){function o(){return new e((function(e,i){r(t,n,e,i)}))}return i=i?i.then(o,o):o()}}function T(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,T(t,r),"throw"===r.method))return d;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return d}var i=l(n,t.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,d;var o=i.arg;return o?o.done?(r[t.resultName]=o.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,d):o:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,d)}function k(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function A(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function S(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(k,this),this.reset(!0)}function j(t){if(t){var r=t[o];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,a=function r(){for(;++i<t.length;)if(n.call(t,i))return r.value=t[i],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:I}}function I(){return{value:e,done:!0}}return g.prototype=O.constructor=m,m.constructor=g,g.displayName=s(m,u,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===g||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,s(t,u,"GeneratorFunction")),t.prototype=Object.create(O),t},t.awrap=function(t){return{__await:t}},E(x.prototype),x.prototype[a]=function(){return this},t.AsyncIterator=x,t.async=function(e,r,n,i,o){void 0===o&&(o=Promise);var a=new x(c(e,r,n,i),o);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},E(O),s(O,u,"Generator"),O[o]=function(){return this},O.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=j,S.prototype={constructor:S,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(A),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function i(n,i){return u.type="throw",u.arg=t,r.next=n,i&&(r.method="next",r.arg=e),!!i}for(var o=this.tryEntries.length-1;o>=0;--o){var a=this.tryEntries[o],u=a.completion;if("root"===a.tryLoc)return i("end");if(a.tryLoc<=this.prev){var s=n.call(a,"catchLoc"),c=n.call(a,"finallyLoc");if(s&&c){if(this.prev<a.catchLoc)return i(a.catchLoc,!0);if(this.prev<a.finallyLoc)return i(a.finallyLoc)}else if(s){if(this.prev<a.catchLoc)return i(a.catchLoc,!0)}else{if(!c)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return i(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var i=this.tryEntries[r];if(i.tryLoc<=this.prev&&n.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var o=i;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=t,a.arg=e,o?(this.method="next",this.next=o.finallyLoc,d):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),d},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),A(r),d}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;A(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:j(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),d}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}}(Vh);var Hh=Vh.exports,$h={exports:{}},Bh=!a((function(){return Object.isExtensible(Object.preventExtensions({}))})),Jh=fe,Kh=nn,Qh=x,Zh=tt,tp=Vt.f,ep=aa,rp=ca,np=Bh,ip=!1,op=nt("meta"),ap=0,up=Object.isExtensible||function(){return!0},sp=function(t){tp(t,op,{value:{objectID:"O"+ap++,weakData:{}}})},cp=$h.exports={enable:function(){cp.enable=function(){},ip=!0;var t=ep.f,e=[].splice,r={};r[op]=1,t(r).length&&(ep.f=function(r){for(var n=t(r),i=0,o=n.length;i<o;i++)if(n[i]===op){e.call(n,i,1);break}return n},Jh({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:rp.f}))},fastKey:function(t,e){if(!Qh(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!Zh(t,op)){if(!up(t))return"F";if(!e)return"E";sp(t)}return t[op].objectID},getWeakData:function(t,e){if(!Zh(t,op)){if(!up(t))return!0;if(!e)return!1;sp(t)}return t[op].weakData},onFreeze:function(t){return np&&ip&&up(t)&&!Zh(t,op)&&sp(t),t}};Kh[op]=!0;var lp=$t,fp=_o,hp=Ce,pp=Gt,vp=So,dp=po,yp=function(t,e){this.stopped=t,this.result=e},gp=function(t,e,r){var n,i,o,a,u,s,c,l=r&&r.that,f=!(!r||!r.AS_ENTRIES),h=!(!r||!r.IS_ITERATOR),p=!(!r||!r.INTERRUPTED),v=pp(e,l,1+f+p),d=function(t){return n&&dp(n),new yp(!0,t)},y=function(t){return f?(lp(t),p?v(t[0],t[1],d):v(t[0],t[1])):p?v(t,d):v(t)};if(h)n=t;else{if("function"!=typeof(i=vp(t)))throw TypeError("Target is not iterable");if(fp(i)){for(o=0,a=hp(t.length);a>o;o++)if((u=y(t[o]))&&u instanceof yp)return u;return new yp(!1)}n=i.call(t)}for(s=n.next;!(c=s.call(n)).done;){try{u=y(c.value)}catch(t){throw dp(n),t}if("object"==typeof u&&u&&u instanceof yp)return u}return new yp(!1)},mp=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},bp=fe,_p=i,wp=$h.exports,Op=a,Ep=re,xp=gp,Tp=mp,kp=x,Ap=Ci,Sp=Vt.f,jp=lr.forEach,Ip=u,Pp=wn.set,Dp=wn.getterFor,Lp=function(t,e,r){var n,i=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),a=i?"set":"add",u=_p[t],s=u&&u.prototype,c={};if(Ip&&"function"==typeof u&&(o||s.forEach&&!Op((function(){(new u).entries().next()})))){n=e((function(e,r){Pp(Tp(e,n,t),{type:t,collection:new u}),null!=r&&xp(r,e[a],{that:e,AS_ENTRIES:i})}));var l=Dp(t);jp(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in s)||o&&"clear"==t||Ep(n.prototype,t,(function(r,n){var i=l(this).collection;if(!e&&o&&!kp(r))return"get"==t&&void 0;var a=i[t](0===r?0:r,n);return e?this:a}))})),o||Sp(n.prototype,"size",{configurable:!0,get:function(){return l(this).collection.size}})}else n=r.getConstructor(e,t,i,a),wp.enable();return Ap(n,t,!1,!0),c[t]=n,bp({global:!0,forced:!0},c),o||r.setStrong(n,t,i),n},Cp=Hi,Mp=j,Np=Vt,Rp=u,Fp=pt("species"),zp=Vt.f,qp=mi,Yp=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:Cp(t,n,e[n],r);return t},Xp=Gt,Wp=mp,Up=gp,Gp=oo,Vp=function(t){var e=Mp(t),r=Np.f;Rp&&e&&!e[Fp]&&r(e,Fp,{configurable:!0,get:function(){return this}})},Hp=u,$p=$h.exports.fastKey,Bp=wn.set,Jp=wn.getterFor,Kp={getConstructor:function(t,e,r,n){var i=t((function(t,o){Wp(t,i,e),Bp(t,{type:e,index:qp(null),first:void 0,last:void 0,size:0}),Hp||(t.size=0),null!=o&&Up(o,t[n],{that:t,AS_ENTRIES:r})})),o=Jp(e),a=function(t,e,r){var n,i,a=o(t),s=u(t,e);return s?s.value=r:(a.last=s={index:i=$p(e,!0),key:e,value:r,previous:n=a.last,next:void 0,removed:!1},a.first||(a.first=s),n&&(n.next=s),Hp?a.size++:t.size++,"F"!==i&&(a.index[i]=s)),t},u=function(t,e){var r,n=o(t),i=$p(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return Yp(i.prototype,{clear:function(){for(var t=o(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,Hp?t.size=0:this.size=0},delete:function(t){var e=this,r=o(e),n=u(e,t);if(n){var i=n.next,a=n.previous;delete r.index[n.index],n.removed=!0,a&&(a.next=i),i&&(i.previous=a),r.first==n&&(r.first=i),r.last==n&&(r.last=a),Hp?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=o(this),n=Xp(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!u(this,t)}}),Yp(i.prototype,r?{get:function(t){var e=u(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),Hp&&zp(i.prototype,"size",{get:function(){return o(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=Jp(e),o=Jp(n);Gp(t,e,(function(t,e){Bp(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),Vp(e)}};Lp("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Kp);var Qp=T.Map,Zp=lr.some;fe({target:"Array",proto:!0,forced:!Xe("some")},{some:function(t){return Zp(this,t,arguments.length>1?arguments[1]:void 0)}});var tv=Te("Array").some,ev=Array.prototype,rv=function(t){var e=t.some;return t===ev||t instanceof Array&&e===ev.some?tv:e},nv=Te("Array").keys,iv=Ti,ov=Array.prototype,av={DOMTokenList:!0,NodeList:!0},uv=function(t){var e=t.keys;return t===ov||t instanceof Array&&e===ov.keys||av.hasOwnProperty(iv(t))?nv:e},sv=Math.floor,cv=function(t,e){var r=t.length,n=sv(r/2);return r<8?lv(t,e):fv(cv(t.slice(0,n),e),cv(t.slice(n),e),e)},lv=function(t,e){for(var r,n,i=t.length,o=1;o<i;){for(n=o,r=t[o];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==o++&&(t[n]=r)}return t},fv=function(t,e,r){for(var n=t.length,i=e.length,o=0,a=0,u=[];o<n||a<i;)o<n&&a<i?u.push(r(t[o],e[a])<=0?t[o++]:e[a++]):u.push(o<n?t[o++]:e[a++]);return u},hv=cv,pv=I.match(/firefox\/(\d+)/i),vv=!!pv&&+pv[1],dv=/MSIE|Trident/.test(I),yv=I.match(/AppleWebKit\/(\d+)\./),gv=!!yv&&+yv[1],mv=fe,bv=Wt,_v=K,wv=Ce,Ov=zr,Ev=a,xv=hv,Tv=Xe,kv=vv,Av=dv,Sv=R,jv=gv,Iv=[],Pv=Iv.sort,Dv=Ev((function(){Iv.sort(void 0)})),Lv=Ev((function(){Iv.sort(null)})),Cv=Tv("sort"),Mv=!Ev((function(){if(Sv)return Sv<70;if(!(kv&&kv>3)){if(Av)return!0;if(jv)return jv<603;var t,e,r,n,i="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)Iv.push({k:e+n,v:r})}for(Iv.sort((function(t,e){return e.v-t.v})),n=0;n<Iv.length;n++)e=Iv[n].k.charAt(0),i.charAt(i.length-1)!==e&&(i+=e);return"DGBEFHACIJK"!==i}}));mv({target:"Array",proto:!0,forced:Dv||!Lv||!Cv||!Mv},{sort:function(t){void 0!==t&&bv(t);var e=_v(this);if(Mv)return void 0===t?Pv.call(e):Pv.call(e,t);var r,n,i=[],o=wv(e.length);for(n=0;n<o;n++)n in e&&i.push(e[n]);for(r=(i=xv(i,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:Ov(e)>Ov(r)?1:-1}}(t))).length,n=0;n<r;)e[n]=i[n++];for(;n<o;)delete e[n++];return e}});var Nv,Rv=Te("Array").sort,Fv=Array.prototype,zv=function(t){var e=t.sort;return t===Fv||t instanceof Array&&e===Fv.sort?Rv:e},qv=Te("Array").values,Yv=Ti,Xv=Array.prototype,Wv={DOMTokenList:!0,NodeList:!0},Uv=function(t){var e=t.values;return t===Xv||t instanceof Array&&e===Xv.values||Wv.hasOwnProperty(Yv(t))?qv:e},Gv=zs,Vv=Te("Array").entries,Hv=Ti,$v=Array.prototype,Bv={DOMTokenList:!0,NodeList:!0},Jv=function(t){var e=t.entries;return t===$v||t instanceof Array&&e===$v.entries||Bv.hasOwnProperty(Hv(t))?Vv:e},Kv=new Uint8Array(16);function Qv(){if(!Nv&&!(Nv="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return Nv(Kv)}var Zv=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function td(t){return"string"==typeof t&&Zv.test(t)}for(var ed=[],rd=0;rd<256;++rd)ed.push((rd+256).toString(16).substr(1));function nd(t,e,r){var n=(t=t||{}).random||(t.rng||Qv)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var i=0;i<16;++i)e[r+i]=n[i];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(ed[t[e+0]]+ed[t[e+1]]+ed[t[e+2]]+ed[t[e+3]]+"-"+ed[t[e+4]]+ed[t[e+5]]+"-"+ed[t[e+6]]+ed[t[e+7]]+"-"+ed[t[e+8]]+ed[t[e+9]]+"-"+ed[t[e+10]]+ed[t[e+11]]+ed[t[e+12]]+ed[t[e+13]]+ed[t[e+14]]+ed[t[e+15]]).toLowerCase();if(!td(r))throw TypeError("Stringified UUID is invalid");return r}(n)}function id(t){return"string"==typeof t||"number"==typeof t}var od=function(){function e(r){t(this,e),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(r)}return ge(e,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Fl((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;oc(t=xc(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(t,r){var n=new e(r);if(void 0!==t.flush)throw new Error("Target object already has a property flush");t.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:t[a]}),n.replace(t,a)}return n._extended={object:t,methods:i},n}}]),e}(),ad=function(){function e(){t(this,e),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=e.prototype.on,this.unsubscribe=e.prototype.off}return ge(e,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");oc(n=Vs(i=[]).call(i,Xs(this._subscribers[t]),Xs(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=mr(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),e}();Lp("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Kp);var ud=T.Set,sd=$t,cd=So,ld=function(t){var e=cd(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return sd(e.call(t))};function fd(t,e){var r=void 0!==Ws&&oa(t)||t["@@iterator"];if(!r){if(Bs(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return hd(t,e);var n=Hs(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Xo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return hd(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function hd(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var pd=function(e){function r(e){t(this,r),this._pairs=e}return ge(r,[{key:Gv,value:Hh.mark((function t(){var e,r,n,i,o;return Hh.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=fd(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Fs(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Hh.mark((function t(){var e,r,n,i,o;return Hh.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=fd(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Fs(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Hh.mark((function t(){var e,r,n,i;return Hh.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=fd(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Fs(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Hh.mark((function t(){var e,r,n,i;return Hh.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=fd(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Fs(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Or(t=Xs(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Or(t=Xs(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Xs(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=xl(null),r=fd(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=Fs(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Qp(this._pairs)}},{key:"toIdSet",value:function(){return new ud(this.toIdArray())}},{key:"toItemSet",value:function(){return new ud(this.toItemArray())}},{key:"cache",value:function(){return new r(Xs(this._pairs))}},{key:"distinct",value:function(t){var e,r=new ud,n=fd(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=Fs(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(t){var e=this._pairs;return new r(ts({},Gv,Hh.mark((function r(){var n,i,o,a,u;return Hh.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=fd(e),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=10;break}if(o=Fs(i.value,2),a=o[0],u=o[1],!t(u,a)){r.next=8;break}return r.next=8,[a,u];case 8:r.next=3;break;case 10:r.next=15;break;case 12:r.prev=12,r.t0=r.catch(1),n.e(r.t0);case 15:return r.prev=15,n.f(),r.finish(15);case 18:case"end":return r.stop()}}),r,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=fd(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=Fs(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(t){var e=this._pairs;return new r(ts({},Gv,Hh.mark((function r(){var n,i,o,a,u;return Hh.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=fd(e),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=9;break}return o=Fs(i.value,2),a=o[0],u=o[1],r.next=7,[a,t(u,a)];case 7:r.next=3;break;case 9:r.next=14;break;case 11:r.prev=11,r.t0=r.catch(1),n.e(r.t0);case 14:return r.prev=14,n.f(),r.finish(14);case 17:case"end":return r.stop()}}),r,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=ld(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Fs(r.value,2),a=o[0],u=o[1],s=t(u,a);s>i&&(i=s,n=u)}return n}},{key:"min",value:function(t){var e=ld(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Fs(r.value,2),a=o[0],u=o[1],s=t(u,a);s<i&&(i=s,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=fd(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=Fs(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(t){var e=this;return new r(ts({},Gv,(function(){var r;return ld(zv(r=Xs(e._pairs)).call(r,(function(e,r){var n=Fs(e,2),i=n[0],o=n[1],a=Fs(r,2),u=a[0],s=a[1];return t(o,s,i,u)})))})))}}]),r}();function vd(t,e){var r=Qs(t);if(ju){var n=ju(t);e&&(n=mr(n).call(n,(function(e){return zu(t,e).enumerable}))),r.push.apply(r,n)}return r}function dd(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)oc(r=vd(Object(n),!0)).call(r,(function(e){ts(t,e,n[e])}));else if($u)Qu(t,$u(n));else{var i;oc(i=vd(Object(n))).call(i,(function(e){Zu(t,e,zu(n,e))}))}}return t}function yd(t,e){var r=void 0!==Ws&&oa(t)||t["@@iterator"];if(!r){if(Bs(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return gd(t,e);var n=Hs(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Xo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return gd(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function gd(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function md(t){var e=function(){if("undefined"==typeof Reflect||!Rh)return!1;if(Rh.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Rh(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Gh(t);if(e){var i=Gh(this).constructor;r=Rh(n,arguments,i)}else r=n.apply(this,arguments);return Wh(this,r)}}var bd=function(e){Yh(n,ad);var r=md(n);function n(e,i){var o;return t(this,n),(o=r.call(this))._queue=null,e&&!Bs(e)&&(i=e,e=[]),o._options=i||{},o._data=new Qp,o.length=0,o._idProp=o._options.fieldId||"id",e&&e.length&&o.add(e),o.setOptions(i),o}return ge(n,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=od.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Ys(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if(Bs(t)){var o=Or(t).call(t,(function(t){return t[n._idProp]}));if(rv(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==Ys(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],u=this._idProp,s=function(t){var e=t[u];if(null!=e&&r._data.has(e)){var s=t,c=Mc({},r._data.get(e)),l=r._updateItem(s);i.push(l),a.push(s),o.push(c)}else{var f=r._addItem(t);n.push(f)}};if(Bs(t))for(var c=0,l=t.length;c<l;c++)t[c]&&"object"===Ys(t[c])?s(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==Ys(t))throw new Error("Unknown dataType");s(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var f={items:i,oldData:o,data:a};this._trigger("update",f,e)}return Vs(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;Bs(t)||(t=[t]);var i=Or(r=Or(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return _h.apply(void 0,Vs(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:Or(i).call(i,(function(t){return t.id})),oldData:Or(i).call(i,(function(t){return t.oldData})),data:Or(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;id(t)?(r=t,i=e):Bs(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",u=i&&mr(i),s=[],c=void 0,l=void 0,f=void 0;if(null!=r)(c=this._data.get(r))&&u&&!u(c)&&(c=void 0);else if(null!=n)for(var h=0,p=n.length;h<p;h++)null==(c=this._data.get(n[h]))||u&&!u(c)||s.push(c);else for(var v,d=0,y=(l=Xs(uv(v=this._data).call(v))).length;d<y;d++)f=l[d],null==(c=this._data.get(f))||u&&!u(c)||s.push(c);if(i&&i.order&&null==r&&this._sort(s,i.order),i&&i.fields){var g=i.fields;if(null!=r&&null!=c)c=this._filterFields(c,g);else for(var m=0,b=s.length;m<b;m++)s[m]=this._filterFields(s[m],g)}if("Object"==a){for(var _={},w=0,O=s.length;w<O;w++){var E=s[w];_[E[this._idProp]]=E}return _}return null!=r?null!==(o=c)&&void 0!==o?o:null:s}},{key:"getIds",value:function(t){var e=this._data,r=t&&mr(t),n=t&&t.order,i=Xs(uv(e).call(e)),o=[];if(r)if(n){for(var a=[],u=0,s=i.length;u<s;u++){var c=i[u],l=this._data.get(c);null!=l&&r(l)&&a.push(l)}this._sort(a,n);for(var f=0,h=a.length;f<h;f++)o.push(a[f][this._idProp])}else for(var p=0,v=i.length;p<v;p++){var d=i[p],y=this._data.get(d);null!=y&&r(y)&&o.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=i.length;m<b;m++){var _=i[m];g.push(e.get(_))}this._sort(g,n);for(var w=0,O=g.length;w<O;w++)o.push(g[w][this._idProp])}else for(var E=0,x=i.length;E<x;E++){var T=i[E],k=e.get(T);null!=k&&o.push(k[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&mr(e),n=this._data,i=Xs(uv(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,u=o.length;a<u;a++){var s=o[a];t(s,s[this._idProp])}else for(var c=0,l=i.length;c<l;c++){var f=i[c],h=this._data.get(f);null==h||r&&!r(h)||t(h,f)}}},{key:"map",value:function(t,e){for(var r=e&&mr(e),n=[],i=this._data,o=Xs(uv(i).call(i)),a=0,u=o.length;a<u;a++){var s=o[a],c=this._data.get(s);null==c||r&&!r(c)||n.push(t(c,s))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?Be(r=Bs(e)?e:Qs(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;zv(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");zv(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=Bs(t)?t:[t],o=0,a=i.length;o<a;o++){var u=this._remove(i[o]);if(u){var s=u[this._idProp];null!=s&&(r.push(s),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(id(t)?e=t:t&&"object"===Ys(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Xs(uv(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=yd(Uv(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u>i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=yd(Uv(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u<i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=Xs(uv(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var u=r[o],s=e.get(u)[t],c=!1,l=0;l<i;l++)if(n[l]==s){c=!0;break}c||void 0===s||(n[i]=s,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=nd()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Cl(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,dd(dd({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new pd(ts({},Gv,Hh.mark((function r(){var n,i,o,a;return Hh.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=yd(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new pd(ts({},Gv,Se(r=Jv(this._data)).call(r,this._data)))}}]),n}();function _d(t,e){var r=void 0!==Ws&&oa(t)||t["@@iterator"];if(!r){if(Bs(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return wd(t,e);var n=Hs(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Xo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return wd(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function wd(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Od(t){var e=function(){if("undefined"==typeof Reflect||!Rh)return!1;if(Rh.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Rh(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=Gh(t);if(e){var i=Gh(this).constructor;r=Rh(n,arguments,i)}else r=n.apply(this,arguments);return Wh(this,r)}}var Ed=function(e){Yh(n,ad);var r=Od(n);function n(e,i){var o,a;return t(this,n),(a=r.call(this)).length=0,a._ids=new ud,a._options=i||{},a._listener=Se(o=a._onEvent).call(o,Xh(a)),a.setData(e),a}return ge(n,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:mr(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:mr(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new bd;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:mr(this._options)}),e=Xs(this._ids),r={},n=[],i=[],o=[],a=0,u=t.length;a<u;a++){var s=t[a];r[s]=!0,this._ids.has(s)||(n.push(s),this._ids.add(s))}for(var c=0,l=e.length;c<l;c++){var f=e[c],h=this._data.get(f);null==h?console.error("If you see this, report it please."):r[f]||(i.push(f),o.push(h),this._ids.delete(f))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;id(t)||Bs(t)?(n=t,r=e):r=t;var i=Mc({},this._options,r),o=mr(this._options),a=r&&mr(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=mr(this._options),n=null!=t?mr(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=mr(this._options),o=e&&mr(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,oc(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=mr(this._options),o=e&&mr(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,Or(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||ts({},Gv,Se(e=uv(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,r="This data view has already been disposed of.",i={get:function(){throw new Error(r)},set:function(){throw new Error(r)},configurable:!1},o=_d($s(n.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;Zu(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],u=[],s=[],c=[];switch(t){case"add":for(var l=0,f=n.length;l<f;l++){var h=n[l];this.get(h)&&(this._ids.add(h),i.push(h))}break;case"update":for(var p=0,v=n.length;p<v;p++){var d=n[p];this.get(d)?this._ids.has(d)?(o.push(d),s.push(e.data[p]),u.push(e.oldData[p])):(this._ids.add(d),i.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),c.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),c.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:u,data:s},r),a.length&&this._trigger("remove",{items:a,oldData:c},r)}}}]),n}();function xd(t,e){return"object"===Ys(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof oc(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Or(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function Td(t,e){return"object"===Ys(e)&&null!==e&&t===e.idProp&&"function"==typeof oc(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Or(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&xd(t,e.getDataSet())}export{bh as DELETE,bd as DataSet,pd as DataStream,Ed as DataView,od as Queue,Mr as createNewDataPipeFrom,xd as isDataSetLike,Td as isDataViewLike};
//# sourceMappingURL=vis-data.min.js.map
