/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.3
 * @date    2022-03-02T13:02:54.265Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){function e(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var r="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{},n={exports:{}},i=function(t){return t&&t.Math==Math&&t},o=i("object"==typeof globalThis&&globalThis)||i("object"==typeof window&&window)||i("object"==typeof self&&self)||i("object"==typeof r&&r)||function(){return this}()||Function("return this")(),a={},u=function(t){try{return!!t()}catch(t){return!0}},s=!u((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),c={},l={}.propertyIsEnumerable,f=Object.getOwnPropertyDescriptor,h=f&&!l.call({1:2},1);c.f=h?function(t){var e=f(this,t);return!!e&&e.enumerable}:l;var p,v,d=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},y={}.toString,g=function(t){return y.call(t).slice(8,-1)},m=g,b="".split,_=u((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==m(t)?b.call(t,""):Object(t)}:Object,w=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},E=_,T=w,O=function(t){return E(T(t))},x=function(t){return"object"==typeof t?null!==t:"function"==typeof t},k={},A=k,S=o,j=function(t){return"function"==typeof t?t:void 0},I=function(t,e){return arguments.length<2?j(A[t])||j(S[t]):A[t]&&A[t][e]||S[t]&&S[t][e]},P=I("navigator","userAgent")||"",D=o,L=P,C=D.process,M=D.Deno,N=C&&C.versions||M&&M.version,R=N&&N.v8;R?v=(p=R.split("."))[0]<4?1:p[0]+p[1]:L&&(!(p=L.match(/Edge\/(\d+)/))||p[1]>=74)&&(p=L.match(/Chrome\/(\d+)/))&&(v=p[1]);var F=v&&+v,z=F,q=u,Y=!!Object.getOwnPropertySymbols&&!q((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&z&&z<41})),X=Y&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,W=I,U=X?function(t){return"symbol"==typeof t}:function(t){var e=W("Symbol");return"function"==typeof e&&Object(t)instanceof e},V=x,G={exports:{}},H=o,$=function(t,e){try{Object.defineProperty(H,t,{value:e,configurable:!0,writable:!0})}catch(r){H[t]=e}return e},B="__core-js_shared__",J=o[B]||$(B,{}),K=J;(G.exports=function(t,e){return K[t]||(K[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.16.1",mode:"pure",copyright:"© 2021 Denis Pushkarev (zloirock.ru)"});var Q=w,Z=function(t){return Object(Q(t))},tt=Z,et={}.hasOwnProperty,rt=Object.hasOwn||function(t,e){return et.call(tt(t),e)},nt=0,it=Math.random(),ot=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++nt+it).toString(36)},at=o,ut=G.exports,st=rt,ct=ot,lt=Y,ft=X,ht=ut("wks"),pt=at.Symbol,vt=ft?pt:pt&&pt.withoutSetter||ct,dt=function(t){return st(ht,t)&&(lt||"string"==typeof ht[t])||(lt&&st(pt,t)?ht[t]=pt[t]:ht[t]=vt("Symbol."+t)),ht[t]},yt=x,gt=U,mt=function(t,e){var r,n;if("string"===e&&"function"==typeof(r=t.toString)&&!V(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!V(n=r.call(t)))return n;if("string"!==e&&"function"==typeof(r=t.toString)&&!V(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},bt=dt("toPrimitive"),_t=function(t,e){if(!yt(t)||gt(t))return t;var r,n=t[bt];if(void 0!==n){if(void 0===e&&(e="default"),r=n.call(t,e),!yt(r)||gt(r))return r;throw TypeError("Can't convert object to primitive value")}return void 0===e&&(e="number"),mt(t,e)},wt=U,Et=function(t){var e=_t(t,"string");return wt(e)?e:String(e)},Tt=x,Ot=o.document,xt=Tt(Ot)&&Tt(Ot.createElement),kt=function(t){return xt?Ot.createElement(t):{}},At=kt,St=!s&&!u((function(){return 7!=Object.defineProperty(At("div"),"a",{get:function(){return 7}}).a})),jt=s,It=c,Pt=d,Dt=O,Lt=Et,Ct=rt,Mt=St,Nt=Object.getOwnPropertyDescriptor;a.f=jt?Nt:function(t,e){if(t=Dt(t),e=Lt(e),Mt)try{return Nt(t,e)}catch(t){}if(Ct(t,e))return Pt(!It.f.call(t,e),t[e])};var Rt=u,Ft=/#|\.prototype\./,zt=function(t,e){var r=Yt[qt(t)];return r==Wt||r!=Xt&&("function"==typeof e?Rt(e):!!e)},qt=zt.normalize=function(t){return String(t).replace(Ft,".").toLowerCase()},Yt=zt.data={},Xt=zt.NATIVE="N",Wt=zt.POLYFILL="P",Ut=zt,Vt=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},Gt=Vt,Ht=function(t,e,r){if(Gt(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,i){return t.call(e,r,n,i)}}return function(){return t.apply(e,arguments)}},$t={},Bt=x,Jt=function(t){if(!Bt(t))throw TypeError(String(t)+" is not an object");return t},Kt=s,Qt=St,Zt=Jt,te=Et,ee=Object.defineProperty;$t.f=Kt?ee:function(t,e,r){if(Zt(t),e=te(e),Zt(r),Qt)try{return ee(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var re=$t,ne=d,ie=s?function(t,e,r){return re.f(t,e,ne(1,r))}:function(t,e,r){return t[e]=r,t},oe=o,ae=a.f,ue=Ut,se=k,ce=Ht,le=ie,fe=rt,he=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},pe=function(t,e){var r,n,i,o,a,u,s,c,l=t.target,f=t.global,h=t.stat,p=t.proto,v=f?oe:h?oe[l]:(oe[l]||{}).prototype,d=f?se:se[l]||(se[l]={}),y=d.prototype;for(i in e)r=!ue(f?i:l+(h?".":"#")+i,t.forced)&&v&&fe(v,i),a=d[i],r&&(u=t.noTargetGet?(c=ae(v,i))&&c.value:v[i]),o=r&&u?u:e[i],r&&typeof a==typeof o||(s=t.bind&&r?ce(o,oe):t.wrap&&r?he(o):p&&"function"==typeof o?ce(Function.call,o):o,(t.sham||o&&o.sham||a&&a.sham)&&le(s,"sham",!0),d[i]=s,p&&(fe(se,n=l+"Prototype")||le(se,n,{}),se[n][i]=o,t.real&&y&&!y[i]&&le(y,i,o)))};pe({target:"Object",stat:!0,forced:!s,sham:!s},{defineProperty:$t.f});var ve=k.Object,de=n.exports=function(t,e,r){return ve.defineProperty(t,e,r)};ve.defineProperty.sham&&(de.sham=!0);var ye=n.exports,ge=ye;function me(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),ge(t,n.key,n)}}function be(t,e,r){return e&&me(t.prototype,e),r&&me(t,r),t}var _e=Vt,we=x,Ee=[].slice,Te={},Oe=function(t,e,r){if(!(e in Te)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";Te[e]=Function("C,a","return new C("+n.join(",")+")")}return Te[e](t,r)},xe=Function.bind||function(t){var e=_e(this),r=Ee.call(arguments,1),n=function(){var i=r.concat(Ee.call(arguments));return this instanceof n?Oe(e,i.length,i):e.apply(t,i)};return we(e.prototype)&&(n.prototype=e.prototype),n};pe({target:"Function",proto:!0},{bind:xe});var ke=k,Ae=function(t){return ke[t+"Prototype"]},Se=Ae("Function").bind,je=Function.prototype,Ie=function(t){var e=t.bind;return t===je||t instanceof Function&&e===je.bind?Se:e},Pe=Math.ceil,De=Math.floor,Le=function(t){return isNaN(t=+t)?0:(t>0?De:Pe)(t)},Ce=Le,Me=Math.min,Ne=function(t){return t>0?Me(Ce(t),9007199254740991):0},Re=Vt,Fe=Z,ze=_,qe=Ne,Ye=function(t){return function(e,r,n,i){Re(r);var o=Fe(e),a=ze(o),u=qe(o.length),s=t?u-1:0,c=t?-1:1;if(n<2)for(;;){if(s in a){i=a[s],s+=c;break}if(s+=c,t?s<0:u<=s)throw TypeError("Reduce of empty array with no initial value")}for(;t?s>=0:u>s;s+=c)s in a&&(i=r(i,a[s],s,o));return i}},Xe={left:Ye(!1),right:Ye(!0)},We=u,Ue=function(t,e){var r=[][t];return!!r&&We((function(){r.call(null,e||function(){throw 1},1)}))},Ve="process"==g(o.process),Ge=Xe.left,He=F,$e=Ve;pe({target:"Array",proto:!0,forced:!Ue("reduce")||!$e&&He>79&&He<83},{reduce:function(t){return Ge(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Be=Ae("Array").reduce,Je=Array.prototype,Ke=function(t){var e=t.reduce;return t===Je||t instanceof Array&&e===Je.reduce?Be:e},Qe=g,Ze=Array.isArray||function(t){return"Array"==Qe(t)},tr=x,er=Ze,rr=dt("species"),nr=function(t){var e;return er(t)&&("function"!=typeof(e=t.constructor)||e!==Array&&!er(e.prototype)?tr(e)&&null===(e=e[rr])&&(e=void 0):e=void 0),void 0===e?Array:e},ir=function(t,e){return new(nr(t))(0===e?0:e)},or=Ht,ar=_,ur=Z,sr=Ne,cr=ir,lr=[].push,fr=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,u=5==t||o;return function(s,c,l,f){for(var h,p,v=ur(s),d=ar(v),y=or(c,l,3),g=sr(d.length),m=0,b=f||cr,_=e?b(s,g):r||a?b(s,0):void 0;g>m;m++)if((u||m in d)&&(p=y(h=d[m],m,v),t))if(e)_[m]=p;else if(p)switch(t){case 3:return!0;case 5:return h;case 6:return m;case 2:lr.call(_,h)}else switch(t){case 4:return!1;case 7:lr.call(_,h)}return o?-1:n||i?i:_}},hr={forEach:fr(0),map:fr(1),filter:fr(2),some:fr(3),every:fr(4),find:fr(5),findIndex:fr(6),filterReject:fr(7)},pr=u,vr=F,dr=dt("species"),yr=function(t){return vr>=51||!pr((function(){var e=[];return(e.constructor={})[dr]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},gr=hr.filter;pe({target:"Array",proto:!0,forced:!yr("filter")},{filter:function(t){return gr(this,t,arguments.length>1?arguments[1]:void 0)}});var mr=Ae("Array").filter,br=Array.prototype,_r=function(t){var e=t.filter;return t===br||t instanceof Array&&e===br.filter?mr:e},wr=hr.map;pe({target:"Array",proto:!0,forced:!yr("map")},{map:function(t){return wr(this,t,arguments.length>1?arguments[1]:void 0)}});var Er=Ae("Array").map,Tr=Array.prototype,Or=function(t){var e=t.map;return t===Tr||t instanceof Array&&e===Tr.map?Er:e},xr=Ze,kr=Ne,Ar=Ht,Sr=function(t,e,r,n,i,o,a,u){for(var s,c=i,l=0,f=!!a&&Ar(a,u,3);l<n;){if(l in r){if(s=f?f(r[l],l,e):r[l],o>0&&xr(s))c=Sr(t,e,s,kr(s.length),c,o-1)-1;else{if(c>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[c]=s}c++}l++}return c},jr=Sr,Ir=Z,Pr=Ne,Dr=Vt,Lr=ir;pe({target:"Array",proto:!0},{flatMap:function(t){var e,r=Ir(this),n=Pr(r.length);return Dr(t),(e=Lr(r,0)).length=jr(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var Cr=Ae("Array").flatMap,Mr=Array.prototype,Nr=function(t){var e=t.flatMap;return t===Mr||t instanceof Array&&e===Mr.flatMap?Cr:e};var Rr=function(){function t(r,n,i){var o,a,u;e(this,t),this._source=r,this._transformers=n,this._target=i,this._listeners={add:Ie(o=this._add).call(o,this),remove:Ie(a=this._remove).call(a,this),update:Ie(u=this._update).call(u,this)}}return be(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return Ke(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),Fr=function(){function t(r){e(this,t),this._source=r,this._transformers=[]}return be(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return _r(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Or(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return Nr(e).call(e,t)})),this}},{key:"to",value:function(t){return new Rr(this._source,this._transformers,t)}}]),t}(),zr=U,qr=function(t){if(zr(t))throw TypeError("Cannot convert a Symbol value to a string");return String(t)},Yr=Le,Xr=qr,Wr=w,Ur=function(t){return function(e,r){var n,i,o=Xr(Wr(e)),a=Yr(r),u=o.length;return a<0||a>=u?t?"":void 0:(n=o.charCodeAt(a))<55296||n>56319||a+1===u||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):n:t?o.slice(a,a+2):i-56320+(n-55296<<10)+65536}},Vr={codeAt:Ur(!1),charAt:Ur(!0)},Gr=J,Hr=Function.toString;"function"!=typeof Gr.inspectSource&&(Gr.inspectSource=function(t){return Hr.call(t)});var $r,Br,Jr,Kr=Gr.inspectSource,Qr=o.WeakMap,Zr="function"==typeof Qr&&/native code/.test(Kr(Qr)),tn=G.exports,en=ot,rn=tn("keys"),nn=function(t){return rn[t]||(rn[t]=en(t))},on={},an=Zr,un=x,sn=ie,cn=rt,ln=J,fn=nn,hn=on,pn="Object already initialized",vn=o.WeakMap;if(an||ln.state){var dn=ln.state||(ln.state=new vn),yn=dn.get,gn=dn.has,mn=dn.set;$r=function(t,e){if(gn.call(dn,t))throw new TypeError(pn);return e.facade=t,mn.call(dn,t,e),e},Br=function(t){return yn.call(dn,t)||{}},Jr=function(t){return gn.call(dn,t)}}else{var bn=fn("state");hn[bn]=!0,$r=function(t,e){if(cn(t,bn))throw new TypeError(pn);return e.facade=t,sn(t,bn,e),e},Br=function(t){return cn(t,bn)?t[bn]:{}},Jr=function(t){return cn(t,bn)}}var _n,wn,En,Tn={set:$r,get:Br,has:Jr,enforce:function(t){return Jr(t)?Br(t):$r(t,{})},getterFor:function(t){return function(e){var r;if(!un(e)||(r=Br(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},On=!u((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),xn=rt,kn=Z,An=On,Sn=nn("IE_PROTO"),jn=Object.prototype,In=An?Object.getPrototypeOf:function(t){return t=kn(t),xn(t,Sn)?t[Sn]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?jn:null},Pn=u,Dn=In,Ln=ie,Cn=rt,Mn=dt("iterator"),Nn=!1;[].keys&&("next"in(En=[].keys())?(wn=Dn(Dn(En)))!==Object.prototype&&(_n=wn):Nn=!0);var Rn=null==_n||Pn((function(){var t={};return _n[Mn].call(t)!==t}));Rn&&(_n={}),Rn&&!Cn(_n,Mn)&&Ln(_n,Mn,(function(){return this}));var Fn,zn={IteratorPrototype:_n,BUGGY_SAFARI_ITERATORS:Nn},qn=Le,Yn=Math.max,Xn=Math.min,Wn=function(t,e){var r=qn(t);return r<0?Yn(r+e,0):Xn(r,e)},Un=O,Vn=Ne,Gn=Wn,Hn=function(t){return function(e,r,n){var i,o=Un(e),a=Vn(o.length),u=Gn(n,a);if(t&&r!=r){for(;a>u;)if((i=o[u++])!=i)return!0}else for(;a>u;u++)if((t||u in o)&&o[u]===r)return t||u||0;return!t&&-1}},$n={includes:Hn(!0),indexOf:Hn(!1)},Bn=rt,Jn=O,Kn=$n.indexOf,Qn=on,Zn=function(t,e){var r,n=Jn(t),i=0,o=[];for(r in n)!Bn(Qn,r)&&Bn(n,r)&&o.push(r);for(;e.length>i;)Bn(n,r=e[i++])&&(~Kn(o,r)||o.push(r));return o},ti=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],ei=Zn,ri=ti,ni=Object.keys||function(t){return ei(t,ri)},ii=$t,oi=Jt,ai=ni,ui=s?Object.defineProperties:function(t,e){oi(t);for(var r,n=ai(e),i=n.length,o=0;i>o;)ii.f(t,r=n[o++],e[r]);return t},si=I("document","documentElement"),ci=Jt,li=ui,fi=ti,hi=on,pi=si,vi=kt,di=nn("IE_PROTO"),yi=function(){},gi=function(t){return"<script>"+t+"</"+"script>"},mi=function(t){t.write(gi("")),t.close();var e=t.parentWindow.Object;return t=null,e},bi=function(){try{Fn=new ActiveXObject("htmlfile")}catch(t){}bi=document.domain&&Fn?mi(Fn):function(){var t,e=vi("iframe");if(e.style)return e.style.display="none",pi.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(gi("document.F=Object")),t.close(),t.F}()||mi(Fn);for(var t=fi.length;t--;)delete bi.prototype[fi[t]];return bi()};hi[di]=!0;var _i=Object.create||function(t,e){var r;return null!==t?(yi.prototype=ci(t),r=new yi,yi.prototype=null,r[di]=t):r=bi(),void 0===e?r:li(r,e)},wi={};wi[dt("toStringTag")]="z";var Ei="[object z]"===String(wi),Ti=Ei,Oi=g,xi=dt("toStringTag"),ki="Arguments"==Oi(function(){return arguments}()),Ai=Ti?Oi:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),xi))?r:ki?Oi(e):"Object"==(n=Oi(e))&&"function"==typeof e.callee?"Arguments":n},Si=Ai,ji=Ei?{}.toString:function(){return"[object "+Si(this)+"]"},Ii=Ei,Pi=$t.f,Di=ie,Li=rt,Ci=ji,Mi=dt("toStringTag"),Ni=function(t,e,r,n){if(t){var i=r?t:t.prototype;Li(i,Mi)||Pi(i,Mi,{configurable:!0,value:e}),n&&!Ii&&Di(i,"toString",Ci)}},Ri={},Fi=zn.IteratorPrototype,zi=_i,qi=d,Yi=Ni,Xi=Ri,Wi=function(){return this},Ui=x,Vi=Jt,Gi=function(t){if(!Ui(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype");return t},Hi=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return Vi(r),Gi(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),$i=ie,Bi=function(t,e,r,n){n&&n.enumerable?t[e]=r:$i(t,e,r)},Ji=pe,Ki=function(t,e,r){var n=e+" Iterator";return t.prototype=zi(Fi,{next:qi(1,r)}),Yi(t,n,!1,!0),Xi[n]=Wi,t},Qi=In,Zi=Ni,to=ie,eo=Bi,ro=Ri,no=zn.IteratorPrototype,io=zn.BUGGY_SAFARI_ITERATORS,oo=dt("iterator"),ao="keys",uo="values",so="entries",co=function(){return this},lo=function(t,e,r,n,i,o,a){Ki(r,e,n);var u,s,c,l=function(t){if(t===i&&d)return d;if(!io&&t in p)return p[t];switch(t){case ao:case uo:case so:return function(){return new r(this,t)}}return function(){return new r(this)}},f=e+" Iterator",h=!1,p=t.prototype,v=p[oo]||p["@@iterator"]||i&&p[i],d=!io&&v||l(i),y="Array"==e&&p.entries||v;if(y&&(u=Qi(y.call(new t)),no!==Object.prototype&&u.next&&(Zi(u,f,!0,!0),ro[f]=co)),i==uo&&v&&v.name!==uo&&(h=!0,d=function(){return v.call(this)}),a&&p[oo]!==d&&to(p,oo,d),ro[e]=d,i)if(s={values:l(uo),keys:o?d:l(ao),entries:l(so)},a)for(c in s)(io||h||!(c in p))&&eo(p,c,s[c]);else Ji({target:e,proto:!0,forced:io||h},s);return s},fo=Vr.charAt,ho=qr,po=Tn,vo=lo,yo="String Iterator",go=po.set,mo=po.getterFor(yo);vo(String,"String",(function(t){go(this,{type:yo,string:ho(t),index:0})}),(function(){var t,e=mo(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=fo(r,n),e.index+=t.length,{value:t,done:!1})}));var bo=Jt,_o=function(t){var e=t.return;if(void 0!==e)return bo(e.call(t)).value},wo=Jt,Eo=_o,To=Ri,Oo=dt("iterator"),xo=Array.prototype,ko=function(t){return void 0!==t&&(To.Array===t||xo[Oo]===t)},Ao=Et,So=$t,jo=d,Io=function(t,e,r){var n=Ao(e);n in t?So.f(t,n,jo(0,r)):t[n]=r},Po=Ai,Do=Ri,Lo=dt("iterator"),Co=function(t){if(null!=t)return t[Lo]||t["@@iterator"]||Do[Po(t)]},Mo=Ht,No=Z,Ro=function(t,e,r,n){try{return n?e(wo(r)[0],r[1]):e(r)}catch(e){throw Eo(t),e}},Fo=ko,zo=Ne,qo=Io,Yo=Co,Xo=dt("iterator"),Wo=!1;try{var Uo=0,Vo={next:function(){return{done:!!Uo++}},return:function(){Wo=!0}};Vo[Xo]=function(){return this},Array.from(Vo,(function(){throw 2}))}catch(t){}var Go=function(t){var e,r,n,i,o,a,u=No(t),s="function"==typeof this?this:Array,c=arguments.length,l=c>1?arguments[1]:void 0,f=void 0!==l,h=Yo(u),p=0;if(f&&(l=Mo(l,c>2?arguments[2]:void 0,2)),null==h||s==Array&&Fo(h))for(r=new s(e=zo(u.length));e>p;p++)a=f?l(u[p],p):u[p],qo(r,p,a);else for(o=(i=h.call(u)).next,r=new s;!(n=o.call(i)).done;p++)a=f?Ro(i,l,[n.value,p],!0):n.value,qo(r,p,a);return r.length=p,r};pe({target:"Array",stat:!0,forced:!function(t,e){if(!e&&!Wo)return!1;var r=!1;try{var n={};n[Xo]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}))},{from:Go});var Ho=k.Array.from,$o=Ho,Bo=O,Jo=Ri,Ko=Tn,Qo=lo,Zo="Array Iterator",ta=Ko.set,ea=Ko.getterFor(Zo);Qo(Array,"Array",(function(t,e){ta(this,{type:Zo,target:Bo(t),index:0,kind:e})}),(function(){var t=ea(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values"),Jo.Arguments=Jo.Array;var ra=Co,na={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},ia=o,oa=Ai,aa=ie,ua=Ri,sa=dt("toStringTag");for(var ca in na){var la=ia[ca],fa=la&&la.prototype;fa&&oa(fa)!==sa&&aa(fa,sa,ca),ua[ca]=ua.Array}var ha=ra,pa={},va=Zn,da=ti.concat("length","prototype");pa.f=Object.getOwnPropertyNames||function(t){return va(t,da)};var ya={},ga=O,ma=pa.f,ba={}.toString,_a="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];ya.f=function(t){return _a&&"[object Window]"==ba.call(t)?function(t){try{return ma(t)}catch(t){return _a.slice()}}(t):ma(ga(t))};var wa={};wa.f=Object.getOwnPropertySymbols;var Ea={},Ta=dt;Ea.f=Ta;var Oa=k,xa=rt,ka=Ea,Aa=$t.f,Sa=function(t){var e=Oa.Symbol||(Oa.Symbol={});xa(e,t)||Aa(e,t,{value:ka.f(t)})},ja=pe,Ia=o,Pa=I,Da=s,La=Y,Ca=u,Ma=rt,Na=Ze,Ra=x,Fa=U,za=Jt,qa=Z,Ya=O,Xa=Et,Wa=qr,Ua=d,Va=_i,Ga=ni,Ha=pa,$a=ya,Ba=wa,Ja=a,Ka=$t,Qa=c,Za=ie,tu=Bi,eu=G.exports,ru=on,nu=ot,iu=dt,ou=Ea,au=Sa,uu=Ni,su=Tn,cu=hr.forEach,lu=nn("hidden"),fu="Symbol",hu=iu("toPrimitive"),pu=su.set,vu=su.getterFor(fu),du=Object.prototype,yu=Ia.Symbol,gu=Pa("JSON","stringify"),mu=Ja.f,bu=Ka.f,_u=$a.f,wu=Qa.f,Eu=eu("symbols"),Tu=eu("op-symbols"),Ou=eu("string-to-symbol-registry"),xu=eu("symbol-to-string-registry"),ku=eu("wks"),Au=Ia.QObject,Su=!Au||!Au.prototype||!Au.prototype.findChild,ju=Da&&Ca((function(){return 7!=Va(bu({},"a",{get:function(){return bu(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=mu(du,e);n&&delete du[e],bu(t,e,r),n&&t!==du&&bu(du,e,n)}:bu,Iu=function(t,e){var r=Eu[t]=Va(yu.prototype);return pu(r,{type:fu,tag:t,description:e}),Da||(r.description=e),r},Pu=function(t,e,r){t===du&&Pu(Tu,e,r),za(t);var n=Xa(e);return za(r),Ma(Eu,n)?(r.enumerable?(Ma(t,lu)&&t[lu][n]&&(t[lu][n]=!1),r=Va(r,{enumerable:Ua(0,!1)})):(Ma(t,lu)||bu(t,lu,Ua(1,{})),t[lu][n]=!0),ju(t,n,r)):bu(t,n,r)},Du=function(t,e){za(t);var r=Ya(e),n=Ga(r).concat(Nu(r));return cu(n,(function(e){Da&&!Lu.call(r,e)||Pu(t,e,r[e])})),t},Lu=function(t){var e=Xa(t),r=wu.call(this,e);return!(this===du&&Ma(Eu,e)&&!Ma(Tu,e))&&(!(r||!Ma(this,e)||!Ma(Eu,e)||Ma(this,lu)&&this[lu][e])||r)},Cu=function(t,e){var r=Ya(t),n=Xa(e);if(r!==du||!Ma(Eu,n)||Ma(Tu,n)){var i=mu(r,n);return!i||!Ma(Eu,n)||Ma(r,lu)&&r[lu][n]||(i.enumerable=!0),i}},Mu=function(t){var e=_u(Ya(t)),r=[];return cu(e,(function(t){Ma(Eu,t)||Ma(ru,t)||r.push(t)})),r},Nu=function(t){var e=t===du,r=_u(e?Tu:Ya(t)),n=[];return cu(r,(function(t){!Ma(Eu,t)||e&&!Ma(du,t)||n.push(Eu[t])})),n};(La||(tu((yu=function(){if(this instanceof yu)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?Wa(arguments[0]):void 0,e=nu(t),r=function(t){this===du&&r.call(Tu,t),Ma(this,lu)&&Ma(this[lu],e)&&(this[lu][e]=!1),ju(this,e,Ua(1,t))};return Da&&Su&&ju(du,e,{configurable:!0,set:r}),Iu(e,t)}).prototype,"toString",(function(){return vu(this).tag})),tu(yu,"withoutSetter",(function(t){return Iu(nu(t),t)})),Qa.f=Lu,Ka.f=Pu,Ja.f=Cu,Ha.f=$a.f=Mu,Ba.f=Nu,ou.f=function(t){return Iu(iu(t),t)},Da&&bu(yu.prototype,"description",{configurable:!0,get:function(){return vu(this).description}})),ja({global:!0,wrap:!0,forced:!La,sham:!La},{Symbol:yu}),cu(Ga(ku),(function(t){au(t)})),ja({target:fu,stat:!0,forced:!La},{for:function(t){var e=Wa(t);if(Ma(Ou,e))return Ou[e];var r=yu(e);return Ou[e]=r,xu[r]=e,r},keyFor:function(t){if(!Fa(t))throw TypeError(t+" is not a symbol");if(Ma(xu,t))return xu[t]},useSetter:function(){Su=!0},useSimple:function(){Su=!1}}),ja({target:"Object",stat:!0,forced:!La,sham:!Da},{create:function(t,e){return void 0===e?Va(t):Du(Va(t),e)},defineProperty:Pu,defineProperties:Du,getOwnPropertyDescriptor:Cu}),ja({target:"Object",stat:!0,forced:!La},{getOwnPropertyNames:Mu,getOwnPropertySymbols:Nu}),ja({target:"Object",stat:!0,forced:Ca((function(){Ba.f(1)}))},{getOwnPropertySymbols:function(t){return Ba.f(qa(t))}}),gu)&&ja({target:"JSON",stat:!0,forced:!La||Ca((function(){var t=yu();return"[null]"!=gu([t])||"{}"!=gu({a:t})||"{}"!=gu(Object(t))}))},{stringify:function(t,e,r){for(var n,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(n=e,(Ra(e)||void 0!==t)&&!Fa(t))return Na(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Fa(e))return e}),i[1]=e,gu.apply(null,i)}});yu.prototype[hu]||Za(yu.prototype,hu,yu.prototype.valueOf),uu(yu,fu),ru[lu]=!0;var Ru=k.Object.getOwnPropertySymbols,Fu={exports:{}},zu=pe,qu=u,Yu=O,Xu=a.f,Wu=s,Uu=qu((function(){Xu(1)}));zu({target:"Object",stat:!0,forced:!Wu||Uu,sham:!Wu},{getOwnPropertyDescriptor:function(t,e){return Xu(Yu(t),e)}});var Vu=k.Object,Gu=Fu.exports=function(t,e){return Vu.getOwnPropertyDescriptor(t,e)};Vu.getOwnPropertyDescriptor.sham&&(Gu.sham=!0);var Hu=Fu.exports,$u=pa,Bu=wa,Ju=Jt,Ku=I("Reflect","ownKeys")||function(t){var e=$u.f(Ju(t)),r=Bu.f;return r?e.concat(r(t)):e},Qu=Ku,Zu=O,ts=a,es=Io;pe({target:"Object",stat:!0,sham:!s},{getOwnPropertyDescriptors:function(t){for(var e,r,n=Zu(t),i=ts.f,o=Qu(n),a={},u=0;o.length>u;)void 0!==(r=i(n,e=o[u++]))&&es(a,e,r);return a}});var rs=k.Object.getOwnPropertyDescriptors,ns={exports:{}};pe({target:"Object",stat:!0,forced:!s,sham:!s},{defineProperties:ui});var is=k.Object,os=ns.exports=function(t,e){return is.defineProperties(t,e)};is.defineProperties.sham&&(os.sham=!0);var as=ns.exports,us=ye;function ss(t,e,r){return e in t?ge(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}pe({target:"Array",stat:!0},{isArray:Ze});var cs=k.Array.isArray,ls=cs;var fs=pe,hs=u,ps=Ze,vs=x,ds=Z,ys=Ne,gs=Io,ms=ir,bs=yr,_s=F,ws=dt("isConcatSpreadable"),Es=9007199254740991,Ts="Maximum allowed index exceeded",Os=_s>=51||!hs((function(){var t=[];return t[ws]=!1,t.concat()[0]!==t})),xs=bs("concat"),ks=function(t){if(!vs(t))return!1;var e=t[ws];return void 0!==e?!!e:ps(t)};fs({target:"Array",proto:!0,forced:!Os||!xs},{concat:function(t){var e,r,n,i,o,a=ds(this),u=ms(a,0),s=0;for(e=-1,n=arguments.length;e<n;e++)if(ks(o=-1===e?a:arguments[e])){if(s+(i=ys(o.length))>Es)throw TypeError(Ts);for(r=0;r<i;r++,s++)r in o&&gs(u,s,o[r])}else{if(s>=Es)throw TypeError(Ts);gs(u,s++,o)}return u.length=s,u}}),Sa("asyncIterator"),Sa("hasInstance"),Sa("isConcatSpreadable"),Sa("iterator"),Sa("match"),Sa("matchAll"),Sa("replace"),Sa("search"),Sa("species"),Sa("split"),Sa("toPrimitive"),Sa("toStringTag"),Sa("unscopables"),Ni(o.JSON,"JSON",!0);var As=k.Symbol;Sa("asyncDispose"),Sa("dispose"),Sa("matcher"),Sa("metadata"),Sa("observable"),Sa("patternMatch"),Sa("replaceAll");var Ss=As;var js=pe,Is=x,Ps=Ze,Ds=Wn,Ls=Ne,Cs=O,Ms=Io,Ns=dt,Rs=yr("slice"),Fs=Ns("species"),zs=[].slice,qs=Math.max;js({target:"Array",proto:!0,forced:!Rs},{slice:function(t,e){var r,n,i,o=Cs(this),a=Ls(o.length),u=Ds(t,a),s=Ds(void 0===e?a:e,a);if(Ps(o)&&("function"!=typeof(r=o.constructor)||r!==Array&&!Ps(r.prototype)?Is(r)&&null===(r=r[Fs])&&(r=void 0):r=void 0,r===Array||void 0===r))return zs.call(o,u,s);for(n=new(void 0===r?Array:r)(qs(s-u,0)),i=0;u<s;u++,i++)u in o&&Ms(n,i,o[u]);return n.length=i,n}});var Ys=Ae("Array").slice,Xs=Array.prototype,Ws=function(t){var e=t.slice;return t===Xs||t instanceof Array&&e===Xs.slice?Ys:e},Us=Ws,Vs=Ho;function Gs(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Hs(t,e){var r;if(t){if("string"==typeof t)return Gs(t,e);var n=Us(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Vs(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Gs(t,e):void 0}}function $s(t,e){return function(t){if(ls(t))return t}(t)||function(t,e){var r=null==t?null:void 0!==Ss&&ha(t)||t["@@iterator"];if(null!=r){var n,i,o=[],a=!0,u=!1;try{for(r=r.call(t);!(a=(n=r.next()).done)&&(o.push(n.value),!e||o.length!==e);a=!0);}catch(t){u=!0,i=t}finally{try{a||null==r.return||r.return()}finally{if(u)throw i}}return o}}(t,e)||Hs(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Bs=Ea.f("iterator"),Js=Bs;function Ks(t){return(Ks="function"==typeof Ss&&"symbol"==typeof Js?function(t){return typeof t}:function(t){return t&&"function"==typeof Ss&&t.constructor===Ss&&t!==Ss.prototype?"symbol":typeof t})(t)}function Qs(t){return function(t){if(ls(t))return Gs(t)}(t)||function(t){if(void 0!==Ss&&null!=ha(t)||null!=t["@@iterator"])return Vs(t)}(t)||Hs(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Zs=As,tc=Ae("Array").concat,ec=Array.prototype,rc=function(t){var e=t.concat;return t===ec||t instanceof Array&&e===ec.concat?tc:e},nc=Ws;pe({target:"Reflect",stat:!0},{ownKeys:Ku});var ic=k.Reflect.ownKeys,oc=cs,ac=Z,uc=ni;pe({target:"Object",stat:!0,forced:u((function(){uc(1)}))},{keys:function(t){return uc(ac(t))}});var sc=k.Object.keys;pe({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}}),k.Date.now;var cc=hr.forEach,lc=Ue("forEach")?[].forEach:function(t){return cc(this,t,arguments.length>1?arguments[1]:void 0)};pe({target:"Array",proto:!0,forced:[].forEach!=lc},{forEach:lc});var fc=Ae("Array").forEach,hc=Ai,pc=Array.prototype,vc={DOMTokenList:!0,NodeList:!0},dc=function(t){var e=t.forEach;return t===pc||t instanceof Array&&e===pc.forEach||vc.hasOwnProperty(hc(t))?fc:e},yc=Ze,gc=[].reverse,mc=[1,2];pe({target:"Array",proto:!0,forced:String(mc)===String(mc.reverse())},{reverse:function(){return yc(this)&&(this.length=this.length),gc.call(this)}});var bc=Ae("Array").reverse,_c=Array.prototype,wc=function(t){var e=t.reverse;return t===_c||t instanceof Array&&e===_c.reverse?bc:e},Ec=pe,Tc=Wn,Oc=Le,xc=Ne,kc=Z,Ac=ir,Sc=Io,jc=yr("splice"),Ic=Math.max,Pc=Math.min,Dc=9007199254740991,Lc="Maximum allowed length exceeded";Ec({target:"Array",proto:!0,forced:!jc},{splice:function(t,e){var r,n,i,o,a,u,s=kc(this),c=xc(s.length),l=Tc(t,c),f=arguments.length;if(0===f?r=n=0:1===f?(r=0,n=c-l):(r=f-2,n=Pc(Ic(Oc(e),0),c-l)),c+r-n>Dc)throw TypeError(Lc);for(i=Ac(s,n),o=0;o<n;o++)(a=l+o)in s&&Sc(i,o,s[a]);if(i.length=n,r<n){for(o=l;o<c-n;o++)u=o+r,(a=o+n)in s?s[u]=s[a]:delete s[u];for(o=c;o>c-n+r;o--)delete s[o-1]}else if(r>n)for(o=c-n;o>l;o--)u=o+r-1,(a=o+n-1)in s?s[u]=s[a]:delete s[u];for(o=0;o<r;o++)s[o+l]=arguments[o+2];return s.length=c-n+r,i}});var Cc=Ae("Array").splice,Mc=Array.prototype,Nc=function(t){var e=t.splice;return t===Mc||t instanceof Array&&e===Mc.splice?Cc:e},Rc=s,Fc=u,zc=ni,qc=wa,Yc=c,Xc=Z,Wc=_,Uc=Object.assign,Vc=Object.defineProperty,Gc=!Uc||Fc((function(){if(Rc&&1!==Uc({b:1},Uc(Vc({},"a",{enumerable:!0,get:function(){Vc(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Uc({},t)[r]||zc(Uc({},e)).join("")!=n}))?function(t,e){for(var r=Xc(t),n=arguments.length,i=1,o=qc.f,a=Yc.f;n>i;)for(var u,s=Wc(arguments[i++]),c=o?zc(s).concat(o(s)):zc(s),l=c.length,f=0;l>f;)u=c[f++],Rc&&!a.call(s,u)||(r[u]=s[u]);return r}:Uc;pe({target:"Object",stat:!0,forced:Object.assign!==Gc},{assign:Gc});var Hc=k.Object.assign,$c=$n.includes;pe({target:"Array",proto:!0},{includes:function(t){return $c(this,t,arguments.length>1?arguments[1]:void 0)}}),Ae("Array").includes;var Bc=x,Jc=g,Kc=dt("match"),Qc=function(t){var e;return Bc(t)&&(void 0!==(e=t[Kc])?!!e:"RegExp"==Jc(t))},Zc=dt("match"),tl=function(t){if(Qc(t))throw TypeError("The method doesn't accept regular expressions");return t},el=w,rl=qr;pe({target:"String",proto:!0,forced:!function(t){var e=/./;try{"/./"[t](e)}catch(r){try{return e[Zc]=!1,"/./"[t](e)}catch(t){}}return!1}("includes")},{includes:function(t){return!!~rl(el(this)).indexOf(rl(tl(t)),arguments.length>1?arguments[1]:void 0)}}),Ae("String").includes;var nl=Z,il=In,ol=On;pe({target:"Object",stat:!0,forced:u((function(){il(1)})),sham:!ol},{getPrototypeOf:function(t){return il(nl(t))}});var al=k.Object.getPrototypeOf,ul=s,sl=ni,cl=O,ll=c.f,fl=function(t){return function(e){for(var r,n=cl(e),i=sl(n),o=i.length,a=0,u=[];o>a;)r=i[a++],ul&&!ll.call(n,r)||u.push(t?[r,n[r]]:n[r]);return u}},hl={entries:fl(!0),values:fl(!1)}.values;pe({target:"Object",stat:!0},{values:function(t){return hl(t)}}),k.Object.values;var pl="\t\n\v\f\r                　\u2028\u2029\ufeff",vl=w,dl=qr,yl="[\t\n\v\f\r                　\u2028\u2029\ufeff]",gl=RegExp("^"+yl+yl+"*"),ml=RegExp(yl+yl+"*$"),bl=function(t){return function(e){var r=dl(vl(e));return 1&t&&(r=r.replace(gl,"")),2&t&&(r=r.replace(ml,"")),r}},_l={start:bl(1),end:bl(2),trim:bl(3)},wl=qr,El=_l.trim,Tl=pl,Ol=o.parseInt,xl=/^[+-]?0[Xx]/,kl=8!==Ol(Tl+"08")||22!==Ol(Tl+"0x16")?function(t,e){var r=El(wl(t));return Ol(r,e>>>0||(xl.test(r)?16:10))}:Ol;pe({global:!0,forced:parseInt!=kl},{parseInt:kl});var Al=pe,Sl=$n.indexOf,jl=Ue,Il=[].indexOf,Pl=!!Il&&1/[1].indexOf(1,-0)<0,Dl=jl("indexOf");Al({target:"Array",proto:!0,forced:Pl||!Dl},{indexOf:function(t){return Pl?Il.apply(this,arguments)||0:Sl(this,t,arguments.length>1?arguments[1]:void 0)}}),Ae("Array").indexOf;var Ll=u,Cl=pl,Ml=_l.trim;pe({target:"String",proto:!0,forced:function(t){return Ll((function(){return!!Cl[t]()||"​᠎"!="​᠎"[t]()||Cl[t].name!==t}))}("trim")},{trim:function(){return Ml(this)}}),Ae("String").trim,pe({target:"Object",stat:!0,sham:!s},{create:_i});var Nl=k.Object,Rl=function(t,e){return Nl.create(t,e)},Fl=Rl,zl=pe,ql=u,Yl=I("JSON","stringify"),Xl=/[\uD800-\uDFFF]/g,Wl=/^[\uD800-\uDBFF]$/,Ul=/^[\uDC00-\uDFFF]$/,Vl=function(t,e,r){var n=r.charAt(e-1),i=r.charAt(e+1);return Wl.test(t)&&!Ul.test(i)||Ul.test(t)&&!Wl.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},Gl=ql((function(){return'"\\udf06\\ud834"'!==Yl("\udf06\ud834")||'"\\udead"'!==Yl("\udead")}));Yl&&zl({target:"JSON",stat:!0,forced:Gl},{stringify:function(t,e,r){var n=Yl.apply(null,arguments);return"string"==typeof n?n.replace(Xl,Vl):n}});var Hl=k;Hl.JSON||(Hl.JSON={stringify:JSON.stringify});var $l=function(t,e,r){return Hl.JSON.stringify.apply(null,arguments)},Bl=o,Jl=[].slice,Kl=function(t){return function(e,r){var n=arguments.length>2,i=n?Jl.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,r)}};pe({global:!0,bind:!0,forced:/MSIE .\./.test(P)},{setTimeout:Kl(Bl.setTimeout),setInterval:Kl(Bl.setInterval)});var Ql=k.setTimeout,Zl=Z,tf=Wn,ef=Ne;pe({target:"Array",proto:!0},{fill:function(t){for(var e=Zl(this),r=ef(e.length),n=arguments.length,i=tf(n>1?arguments[1]:void 0,r),o=n>2?arguments[2]:void 0,a=void 0===o?r:tf(o,r);a>i;)e[i++]=t;return e}}),Ae("Array").fill;var rf={exports:{}};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}(rf);var nf=rf.exports;
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
   * http://naver.github.io/egjs
   *
   * Forked By Naver egjs
   * Copyright (c) hammerjs
   * Licensed under the MIT license */function of(){return(of=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t}).apply(this,arguments)}function af(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function uf(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var sf,cf="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign,lf=["","webkit","Moz","MS","ms","o"],ff="undefined"==typeof document?{style:{}}:document.createElement("div"),hf=Math.round,pf=Math.abs,vf=Date.now;function df(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<lf.length;){if((n=(r=lf[o])?r+i:e)in t)return n;o++}}sf="undefined"==typeof window?{}:window;var yf=df(ff.style,"touchAction"),gf=void 0!==yf;var mf="compute",bf="auto",_f="manipulation",wf="none",Ef="pan-x",Tf="pan-y",Of=function(){if(!gf)return!1;var t={},e=sf.CSS&&sf.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||sf.CSS.supports("touch-action",r)})),t}(),xf="ontouchstart"in sf,kf=void 0!==df(sf,"PointerEvent"),Af=xf&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Sf="touch",jf="mouse",If=16,Pf=24,Df=["x","y"],Lf=["clientX","clientY"];function Cf(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function Mf(t,e){return"function"==typeof t?t.apply(e&&e[0]||void 0,e):t}function Nf(t,e){return t.indexOf(e)>-1}var Rf=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===mf&&(t=this.compute()),gf&&this.manager.element.style&&Of[t]&&(this.manager.element.style[yf]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Cf(this.manager.recognizers,(function(e){Mf(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Nf(t,wf))return wf;var e=Nf(t,Ef),r=Nf(t,Tf);return e&&r?wf:e||r?e?Ef:Tf:Nf(t,_f)?_f:bf}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=Nf(n,wf)&&!Of.none,o=Nf(n,Tf)&&!Of["pan-y"],a=Nf(n,Ef)&&!Of["pan-x"];if(i){var u=1===t.pointers.length,s=t.distance<2,c=t.deltaTime<250;if(u&&s&&c)return}if(!a||!o)return i||o&&6&r||a&&r&Pf?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function Ff(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function zf(t){var e=t.length;if(1===e)return{x:hf(t[0].clientX),y:hf(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:hf(r/e),y:hf(n/e)}}function qf(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:hf(t.pointers[r].clientX),clientY:hf(t.pointers[r].clientY)},r++;return{timeStamp:vf(),pointers:e,center:zf(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Yf(t,e,r){r||(r=Df);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function Xf(t,e,r){r||(r=Df);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function Wf(t,e){return t===e?1:pf(t)>=pf(e)?t<0?2:4:e<0?8:If}function Uf(t,e,r){return{x:e/t||0,y:r/t||0}}function Vf(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=qf(e)),i>1&&!r.firstMultiple?r.firstMultiple=qf(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,u=a?a.center:o.center,s=e.center=zf(n);e.timeStamp=vf(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=Xf(u,s),e.distance=Yf(u,s),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};1!==e.eventType&&4!==o.eventType||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=Wf(e.deltaX,e.deltaY);var c,l,f=Uf(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=f.x,e.overallVelocityY=f.y,e.overallVelocity=pf(f.x)>pf(f.y)?f.x:f.y,e.scale=a?(c=a.pointers,Yf((l=n)[0],l[1],Lf)/Yf(c[0],c[1],Lf)):1,e.rotation=a?function(t,e){return Xf(e[1],e[0],Lf)+Xf(t[1],t[0],Lf)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,u=e.timeStamp-a.timeStamp;if(8!==e.eventType&&(u>25||void 0===a.velocity)){var s=e.deltaX-a.deltaX,c=e.deltaY-a.deltaY,l=Uf(u,s,c);n=l.x,i=l.y,r=pf(l.x)>pf(l.y)?l.x:l.y,o=Wf(s,c),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var h,p=t.element,v=e.srcEvent;Ff(h=v.composedPath?v.composedPath()[0]:v.path?v.path[0]:v.target,p)&&(p=h),e.target=p}function Gf(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=1&e&&n-i==0,a=12&e&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,Vf(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function Hf(t){return t.trim().split(/\s+/g)}function $f(t,e,r){Cf(Hf(e),(function(e){t.addEventListener(e,r,!1)}))}function Bf(t,e,r){Cf(Hf(e),(function(e){t.removeEventListener(e,r,!1)}))}function Jf(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var Kf=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Mf(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&$f(this.element,this.evEl,this.domHandler),this.evTarget&&$f(this.target,this.evTarget,this.domHandler),this.evWin&&$f(Jf(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&Bf(this.element,this.evEl,this.domHandler),this.evTarget&&Bf(this.target,this.evTarget,this.domHandler),this.evWin&&Bf(Jf(this.element),this.evWin,this.domHandler)},t}();function Qf(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var Zf={pointerdown:1,pointermove:2,pointerup:4,pointercancel:8,pointerout:8},th={2:Sf,3:"pen",4:jf,5:"kinect"},eh="pointerdown",rh="pointermove pointerup pointercancel";sf.MSPointerEvent&&!sf.PointerEvent&&(eh="MSPointerDown",rh="MSPointerMove MSPointerUp MSPointerCancel");var nh=function(t){function e(){var r,n=e.prototype;return n.evEl=eh,n.evWin=rh,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return af(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=Zf[n],o=th[t.pointerType]||t.pointerType,a=o===Sf,u=Qf(e,t.pointerId,"pointerId");1&i&&(0===t.button||a)?u<0&&(e.push(t),u=e.length-1):12&i&&(r=!0),u<0||(e[u]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(u,1))},e}(Kf);function ih(t){return Array.prototype.slice.call(t,0)}function oh(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];Qf(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var ah={touchstart:1,touchmove:2,touchend:4,touchcancel:8},uh="touchstart touchmove touchend touchcancel",sh=function(t){function e(){var r;return e.prototype.evTarget=uh,(r=t.apply(this,arguments)||this).targetIds={},r}return af(e,t),e.prototype.handler=function(t){var e=ah[t.type],r=ch.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Sf,srcEvent:t})},e}(Kf);function ch(t,e){var r,n,i=ih(t.touches),o=this.targetIds;if(3&e&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=ih(t.changedTouches),u=[],s=this.target;if(n=i.filter((function(t){return Ff(t.target,s)})),1===e)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&u.push(a[r]),12&e&&delete o[a[r].identifier],r++;return u.length?[oh(n.concat(u),"identifier",!0),u]:void 0}var lh={mousedown:1,mousemove:2,mouseup:4},fh="mousedown",hh="mousemove mouseup",ph=function(t){function e(){var r,n=e.prototype;return n.evEl=fh,n.evWin=hh,(r=t.apply(this,arguments)||this).pressed=!1,r}return af(e,t),e.prototype.handler=function(t){var e=lh[t.type];1&e&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=4),this.pressed&&(4&e&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:jf,srcEvent:t}))},e}(Kf);function vh(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),2500)}}function dh(t,e){1&t?(this.primaryTouch=e.changedPointers[0].identifier,vh.call(this,e)):12&t&&vh.call(this,e)}function yh(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=25&&a<=25)return!0}return!1}var gh=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i=r.pointerType===Sf,o=r.pointerType===jf;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)dh.call(uf(uf(n)),e,r);else if(o&&yh.call(uf(uf(n)),r))return;n.callback(t,e,r)}},n.touch=new sh(n.manager,n.handler),n.mouse=new ph(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return af(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(Kf)}();function mh(t,e,r){return!!Array.isArray(t)&&(Cf(t,r[e],r),!0)}var bh=32,_h=1;function wh(t,e){var r=e.manager;return r?r.get(t):t}function Eh(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}var Th=function(){function t(t){void 0===t&&(t={}),this.options=of({enable:!0},t),this.id=_h++,this.manager=null,this.state=1,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return cf(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(mh(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=wh(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return mh(t,"dropRecognizeWith",this)||(t=wh(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(mh(t,"requireFailure",this))return this;var e=this.requireFail;return-1===Qf(e,t=wh(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(mh(t,"dropRequireFailure",this))return this;t=wh(t,this);var e=Qf(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<8&&n(e.options.event+Eh(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=8&&n(e.options.event+Eh(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=bh},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},e.recognize=function(t){var e=cf({},t);if(!Mf(this.options.enable,[this,e]))return this.reset(),void(this.state=bh);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Oh=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,of({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}af(e,t);var r=e.prototype;return r.getTouchAction=function(){return[_f]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),1&t.eventType&&0===this.count)return this.failTimeout();if(i&&o&&n){if(4!==t.eventType)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,u=!this.pCenter||Yf(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,u&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.interval),2):8}return bh},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=bh}),this.options.interval),bh},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){8===this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Th),xh=function(t){function e(e){return void 0===e&&(e={}),t.call(this,of({pointers:1},e))||this}af(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=6&e,i=this.attrTest(t);return n&&(8&r||!i)?16|e:n||i?4&r?8|e:2&e?4|e:2:bh},e}(Th);function kh(t){return t===If?"down":8===t?"up":2===t?"left":4===t?"right":""}var Ah=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,of({event:"pan",threshold:10,pointers:1,direction:30},e))||this).pX=null,r.pY=null,r}af(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return 6&t&&e.push(Tf),t&Pf&&e.push(Ef),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(6&e.direction?(i=0===o?1:o<0?2:4,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?1:a<0?8:If,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return xh.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=kh(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(xh),Sh=function(t){function e(e){return void 0===e&&(e={}),t.call(this,of({event:"swipe",threshold:10,velocity:.3,direction:30,pointers:1},e))||this}af(e,t);var r=e.prototype;return r.getTouchAction=function(){return Ah.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return 30&n?r=e.overallVelocity:6&n?r=e.overallVelocityX:n&Pf&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&pf(r)>this.options.velocity&&4&e.eventType},r.emit=function(t){var e=kh(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(xh),jh=function(t){function e(e){return void 0===e&&(e={}),t.call(this,of({event:"pinch",threshold:0,pointers:2},e))||this}af(e,t);var r=e.prototype;return r.getTouchAction=function(){return[wf]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||2&this.state)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(xh),Ih=function(t){function e(e){return void 0===e&&(e={}),t.call(this,of({event:"rotate",threshold:0,pointers:2},e))||this}af(e,t);var r=e.prototype;return r.getTouchAction=function(){return[wf]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||2&this.state)},e}(xh),Ph=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,of({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}af(e,t);var r=e.prototype;return r.getTouchAction=function(){return[bf]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||12&t.eventType&&!o)this.reset();else if(1&t.eventType)this.reset(),this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.time);else if(4&t.eventType)return 8;return bh},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){8===this.state&&(t&&4&t.eventType?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=vf(),this.manager.emit(this.options.event,this._input)))},e}(Th),Dh={domEvents:!1,touchAction:mf,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},Lh=[[Ih,{enable:!1}],[jh,{enable:!1},["rotate"]],[Sh,{direction:6}],[Ah,{direction:6},["swipe"]],[Oh],[Oh,{event:"doubletap",taps:2},["tap"]],[Ph]];function Ch(t,e){var r,n=t.element;n.style&&(Cf(t.options.cssProps,(function(i,o){r=df(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var Mh=function(){function t(t,e){var r,n=this;this.options=cf({},Dh,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(kf?nh:Af?sh:xf?gh:ph))(r,Gf),this.touchAction=new Rf(this,this.options.touchAction),Ch(this,!0),Cf(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return cf(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&8&i.state)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&14&r.state&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof Th)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(mh(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(mh(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=Qf(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return Cf(Hf(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return Cf(Hf(t),(function(t){e?r[t]&&r[t].splice(Qf(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&Ch(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Nh={touchstart:1,touchmove:2,touchend:4,touchcancel:8},Rh="touchstart",Fh="touchstart touchmove touchend touchcancel",zh=function(t){function e(){var r,n=e.prototype;return n.evTarget=Rh,n.evWin=Fh,(r=t.apply(this,arguments)||this).started=!1,r}return af(e,t),e.prototype.handler=function(t){var e=Nh[t.type];if(1===e&&(this.started=!0),this.started){var r=qh.call(this,t,e);12&e&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:Sf,srcEvent:t})}},e}(Kf);function qh(t,e){var r=ih(t.touches),n=ih(t.changedTouches);return 12&e&&(r=oh(r.concat(n),"identifier",!0)),[r,n]}function Yh(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var Xh=Yh((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),Wh=Yh((function(t,e){return Xh(t,e,!0)}),"merge","Use `assign`.");function Uh(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&cf(n,r)}function Vh(t,e){return function(){return t.apply(e,arguments)}}var Gh=function(){var t=function(t,e){return void 0===e&&(e={}),new Mh(t,of({recognizers:Lh.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=30,t.DIRECTION_DOWN=If,t.DIRECTION_LEFT=2,t.DIRECTION_RIGHT=4,t.DIRECTION_UP=8,t.DIRECTION_HORIZONTAL=6,t.DIRECTION_VERTICAL=Pf,t.DIRECTION_NONE=1,t.DIRECTION_DOWN=If,t.INPUT_START=1,t.INPUT_MOVE=2,t.INPUT_END=4,t.INPUT_CANCEL=8,t.STATE_POSSIBLE=1,t.STATE_BEGAN=2,t.STATE_CHANGED=4,t.STATE_ENDED=8,t.STATE_RECOGNIZED=8,t.STATE_CANCELLED=16,t.STATE_FAILED=bh,t.Manager=Mh,t.Input=Kf,t.TouchAction=Rf,t.TouchInput=sh,t.MouseInput=ph,t.PointerEventInput=nh,t.TouchMouseInput=gh,t.SingleTouchInput=zh,t.Recognizer=Th,t.AttrRecognizer=xh,t.Tap=Oh,t.Pan=Ah,t.Swipe=Sh,t.Pinch=jh,t.Rotate=Ih,t.Press=Ph,t.on=$f,t.off=Bf,t.each=Cf,t.merge=Wh,t.extend=Xh,t.bindFn=Vh,t.assign=cf,t.inherit=Uh,t.bindFn=Vh,t.prefixed=df,t.toArray=ih,t.inArray=Qf,t.uniqueArray=oh,t.splitStr=Hf,t.boolOrFn=Mf,t.hasParent=Ff,t.addEventListeners=$f,t.removeEventListeners=Bf,t.defaults=cf({},Dh,{preset:Lh}),t}();function Hh(t,e){var r=void 0!==Zs&&ha(t)||t["@@iterator"];if(!r){if(oc(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return $h(t,e);var n=nc(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return $o(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return $h(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function $h(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var Bh=Zs("DELETE");function Jh(){var t=Kh.apply(void 0,arguments);return Zh(t),t}function Kh(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Kh.apply(void 0,rc(n=[Jh(e[0],e[1])]).call(n,Qs(nc(e).call(e,2))));var i,o=e[0],a=e[1],u=Hh(ic(a));try{for(u.s();!(i=u.n()).done;){var s=i.value;Object.prototype.propertyIsEnumerable.call(a,s)&&(a[s]===Bh?delete o[s]:null===o[s]||null===a[s]||"object"!==Ks(o[s])||"object"!==Ks(a[s])||oc(o[s])||oc(a[s])?o[s]=Qh(a[s]):o[s]=Kh(o[s],a[s]))}}catch(t){u.e(t)}finally{u.f()}return o}function Qh(t){return oc(t)?Or(t).call(t,(function(t){return Qh(t)})):"object"===Ks(t)&&null!==t?Kh({},t):t}function Zh(t){for(var e=0,r=sc(t);e<r.length;e++){var n=r[e];t[n]===Bh?delete t[n]:"object"===Ks(t[n])&&null!==t[n]&&Zh(t[n])}}var tp="undefined"!=typeof window?window.Hammer||Gh:function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(){return{set:t}}};var t};function ep(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=tp(this._dom.overlay);n.on("tap",Ie(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];dc(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}nf(ep.prototype),ep.current=null,ep.prototype.destroy=function(){var t,e;this.deactivate();var r,n=Hh(wc(t=Nc(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},ep.prototype.activate=function(){ep.current&&ep.current.deactivate(),ep.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},ep.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},ep.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var rp=pe,np=Vt,ip=Jt,op=x,ap=_i,up=xe,sp=u,cp=I("Reflect","construct"),lp=sp((function(){function t(){}return!(cp((function(){}),[],t)instanceof t)})),fp=!sp((function(){cp((function(){}))})),hp=lp||fp;rp({target:"Reflect",stat:!0,forced:hp,sham:hp},{construct:function(t,e){np(t),ip(e);var r=arguments.length<3?t:np(arguments[2]);if(fp&&!lp)return cp(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(up.apply(t,n))}var i=r.prototype,o=ap(op(i)?i:Object.prototype),a=Function.apply.call(t,o,e);return op(a)?a:o}});var pp=k.Reflect.construct,vp=Rl;pe({target:"Object",stat:!0},{setPrototypeOf:Hi});var dp=k.Object.setPrototypeOf;function yp(t,e){return(yp=dp||function(t,e){return t.__proto__=e,t})(t,e)}function gp(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=vp(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&yp(t,e)}function mp(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}function bp(t,e){if(e&&("object"===Ks(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return mp(t)}var _p=al;function wp(t){return(wp=dp?_p:function(t){return t.__proto__||_p(t)})(t)}var Ep={exports:{}};!function(t){var e=function(t){var e,r=Object.prototype,n=r.hasOwnProperty,i="function"==typeof Symbol?Symbol:{},o=i.iterator||"@@iterator",a=i.asyncIterator||"@@asyncIterator",u=i.toStringTag||"@@toStringTag";function s(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{s({},"")}catch(t){s=function(t,e,r){return t[e]=r}}function c(t,e,r,n){var i=e&&e.prototype instanceof y?e:y,o=Object.create(i.prototype),a=new S(n||[]);return o._invoke=function(t,e,r){var n=f;return function(i,o){if(n===p)throw new Error("Generator is already running");if(n===v){if("throw"===i)throw o;return I()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var u=x(a,r);if(u){if(u===d)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if(n===f)throw n=v,r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n=p;var s=l(t,e,r);if("normal"===s.type){if(n=r.done?v:h,s.arg===d)continue;return{value:s.arg,done:r.done}}"throw"===s.type&&(n=v,r.method="throw",r.arg=s.arg)}}}(t,r,a),o}function l(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=c;var f="suspendedStart",h="suspendedYield",p="executing",v="completed",d={};function y(){}function g(){}function m(){}var b={};b[o]=function(){return this};var _=Object.getPrototypeOf,w=_&&_(_(j([])));w&&w!==r&&n.call(w,o)&&(b=w);var E=m.prototype=y.prototype=Object.create(b);function T(t){["next","throw","return"].forEach((function(e){s(t,e,(function(t){return this._invoke(e,t)}))}))}function O(t,e){function r(i,o,a,u){var s=l(t[i],t,o);if("throw"!==s.type){var c=s.arg,f=c.value;return f&&"object"==typeof f&&n.call(f,"__await")?e.resolve(f.__await).then((function(t){r("next",t,a,u)}),(function(t){r("throw",t,a,u)})):e.resolve(f).then((function(t){c.value=t,a(c)}),(function(t){return r("throw",t,a,u)}))}u(s.arg)}var i;this._invoke=function(t,n){function o(){return new e((function(e,i){r(t,n,e,i)}))}return i=i?i.then(o,o):o()}}function x(t,r){var n=t.iterator[r.method];if(n===e){if(r.delegate=null,"throw"===r.method){if(t.iterator.return&&(r.method="return",r.arg=e,x(t,r),"throw"===r.method))return d;r.method="throw",r.arg=new TypeError("The iterator does not provide a 'throw' method")}return d}var i=l(n,t.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,d;var o=i.arg;return o?o.done?(r[t.resultName]=o.value,r.next=t.nextLoc,"return"!==r.method&&(r.method="next",r.arg=e),r.delegate=null,d):o:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,d)}function k(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function A(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function S(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(k,this),this.reset(!0)}function j(t){if(t){var r=t[o];if(r)return r.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var i=-1,a=function r(){for(;++i<t.length;)if(n.call(t,i))return r.value=t[i],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}return{next:I}}function I(){return{value:e,done:!0}}return g.prototype=E.constructor=m,m.constructor=g,g.displayName=s(m,u,"GeneratorFunction"),t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===g||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,s(t,u,"GeneratorFunction")),t.prototype=Object.create(E),t},t.awrap=function(t){return{__await:t}},T(O.prototype),O.prototype[a]=function(){return this},t.AsyncIterator=O,t.async=function(e,r,n,i,o){void 0===o&&(o=Promise);var a=new O(c(e,r,n,i),o);return t.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},T(E),s(E,u,"Generator"),E[o]=function(){return this},E.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=j,S.prototype={constructor:S,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method="next",this.arg=e,this.tryEntries.forEach(A),!t)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function i(n,i){return u.type="throw",u.arg=t,r.next=n,i&&(r.method="next",r.arg=e),!!i}for(var o=this.tryEntries.length-1;o>=0;--o){var a=this.tryEntries[o],u=a.completion;if("root"===a.tryLoc)return i("end");if(a.tryLoc<=this.prev){var s=n.call(a,"catchLoc"),c=n.call(a,"finallyLoc");if(s&&c){if(this.prev<a.catchLoc)return i(a.catchLoc,!0);if(this.prev<a.finallyLoc)return i(a.finallyLoc)}else if(s){if(this.prev<a.catchLoc)return i(a.catchLoc,!0)}else{if(!c)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return i(a.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var i=this.tryEntries[r];if(i.tryLoc<=this.prev&&n.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var o=i;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=t,a.arg=e,o?(this.method="next",this.next=o.finallyLoc,d):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),d},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),A(r),d}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;A(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,r,n){return this.delegate={iterator:j(t),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=e),d}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}}(Ep);var Tp=Ep.exports,Op={exports:{}},xp=!u((function(){return Object.isExtensible(Object.preventExtensions({}))})),kp=pe,Ap=on,Sp=x,jp=rt,Ip=$t.f,Pp=pa,Dp=ya,Lp=xp,Cp=!1,Mp=ot("meta"),Np=0,Rp=Object.isExtensible||function(){return!0},Fp=function(t){Ip(t,Mp,{value:{objectID:"O"+Np++,weakData:{}}})},zp=Op.exports={enable:function(){zp.enable=function(){},Cp=!0;var t=Pp.f,e=[].splice,r={};r[Mp]=1,t(r).length&&(Pp.f=function(r){for(var n=t(r),i=0,o=n.length;i<o;i++)if(n[i]===Mp){e.call(n,i,1);break}return n},kp({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:Dp.f}))},fastKey:function(t,e){if(!Sp(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!jp(t,Mp)){if(!Rp(t))return"F";if(!e)return"E";Fp(t)}return t[Mp].objectID},getWeakData:function(t,e){if(!jp(t,Mp)){if(!Rp(t))return!0;if(!e)return!1;Fp(t)}return t[Mp].weakData},onFreeze:function(t){return Lp&&Cp&&Rp(t)&&!jp(t,Mp)&&Fp(t),t}};Ap[Mp]=!0;var qp=Jt,Yp=ko,Xp=Ne,Wp=Ht,Up=Co,Vp=_o,Gp=function(t,e){this.stopped=t,this.result=e},Hp=function(t,e,r){var n,i,o,a,u,s,c,l=r&&r.that,f=!(!r||!r.AS_ENTRIES),h=!(!r||!r.IS_ITERATOR),p=!(!r||!r.INTERRUPTED),v=Wp(e,l,1+f+p),d=function(t){return n&&Vp(n),new Gp(!0,t)},y=function(t){return f?(qp(t),p?v(t[0],t[1],d):v(t[0],t[1])):p?v(t,d):v(t)};if(h)n=t;else{if("function"!=typeof(i=Up(t)))throw TypeError("Target is not iterable");if(Yp(i)){for(o=0,a=Xp(t.length);a>o;o++)if((u=y(t[o]))&&u instanceof Gp)return u;return new Gp(!1)}n=i.call(t)}for(s=n.next;!(c=s.call(n)).done;){try{u=y(c.value)}catch(t){throw Vp(n),t}if("object"==typeof u&&u&&u instanceof Gp)return u}return new Gp(!1)},$p=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},Bp=pe,Jp=o,Kp=Op.exports,Qp=u,Zp=ie,tv=Hp,ev=$p,rv=x,nv=Ni,iv=$t.f,ov=hr.forEach,av=s,uv=Tn.set,sv=Tn.getterFor,cv=function(t,e,r){var n,i=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),a=i?"set":"add",u=Jp[t],s=u&&u.prototype,c={};if(av&&"function"==typeof u&&(o||s.forEach&&!Qp((function(){(new u).entries().next()})))){n=e((function(e,r){uv(ev(e,n,t),{type:t,collection:new u}),null!=r&&tv(r,e[a],{that:e,AS_ENTRIES:i})}));var l=sv(t);ov(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in s)||o&&"clear"==t||Zp(n.prototype,t,(function(r,n){var i=l(this).collection;if(!e&&o&&!rv(r))return"get"==t&&void 0;var a=i[t](0===r?0:r,n);return e?this:a}))})),o||iv(n.prototype,"size",{configurable:!0,get:function(){return l(this).collection.size}})}else n=r.getConstructor(e,t,i,a),Kp.enable();return nv(n,t,!1,!0),c[t]=n,Bp({global:!0,forced:!0},c),o||r.setStrong(n,t,i),n},lv=Bi,fv=I,hv=$t,pv=s,vv=dt("species"),dv=$t.f,yv=_i,gv=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:lv(t,n,e[n],r);return t},mv=Ht,bv=$p,_v=Hp,wv=lo,Ev=function(t){var e=fv(t),r=hv.f;pv&&e&&!e[vv]&&r(e,vv,{configurable:!0,get:function(){return this}})},Tv=s,Ov=Op.exports.fastKey,xv=Tn.set,kv=Tn.getterFor,Av={getConstructor:function(t,e,r,n){var i=t((function(t,o){bv(t,i,e),xv(t,{type:e,index:yv(null),first:void 0,last:void 0,size:0}),Tv||(t.size=0),null!=o&&_v(o,t[n],{that:t,AS_ENTRIES:r})})),o=kv(e),a=function(t,e,r){var n,i,a=o(t),s=u(t,e);return s?s.value=r:(a.last=s={index:i=Ov(e,!0),key:e,value:r,previous:n=a.last,next:void 0,removed:!1},a.first||(a.first=s),n&&(n.next=s),Tv?a.size++:t.size++,"F"!==i&&(a.index[i]=s)),t},u=function(t,e){var r,n=o(t),i=Ov(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return gv(i.prototype,{clear:function(){for(var t=o(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,Tv?t.size=0:this.size=0},delete:function(t){var e=this,r=o(e),n=u(e,t);if(n){var i=n.next,a=n.previous;delete r.index[n.index],n.removed=!0,a&&(a.next=i),i&&(i.previous=a),r.first==n&&(r.first=i),r.last==n&&(r.last=a),Tv?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=o(this),n=mv(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!u(this,t)}}),gv(i.prototype,r?{get:function(t){var e=u(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),Tv&&dv(i.prototype,"size",{get:function(){return o(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=kv(e),o=kv(n);wv(t,e,(function(t,e){xv(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),Ev(e)}};cv("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Av);var Sv=k.Map,jv=hr.some;pe({target:"Array",proto:!0,forced:!Ue("some")},{some:function(t){return jv(this,t,arguments.length>1?arguments[1]:void 0)}});var Iv=Ae("Array").some,Pv=Array.prototype,Dv=function(t){var e=t.some;return t===Pv||t instanceof Array&&e===Pv.some?Iv:e},Lv=Ae("Array").keys,Cv=Ai,Mv=Array.prototype,Nv={DOMTokenList:!0,NodeList:!0},Rv=function(t){var e=t.keys;return t===Mv||t instanceof Array&&e===Mv.keys||Nv.hasOwnProperty(Cv(t))?Lv:e},Fv=Math.floor,zv=function(t,e){var r=t.length,n=Fv(r/2);return r<8?qv(t,e):Yv(zv(t.slice(0,n),e),zv(t.slice(n),e),e)},qv=function(t,e){for(var r,n,i=t.length,o=1;o<i;){for(n=o,r=t[o];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==o++&&(t[n]=r)}return t},Yv=function(t,e,r){for(var n=t.length,i=e.length,o=0,a=0,u=[];o<n||a<i;)o<n&&a<i?u.push(r(t[o],e[a])<=0?t[o++]:e[a++]):u.push(o<n?t[o++]:e[a++]);return u},Xv=zv,Wv=P.match(/firefox\/(\d+)/i),Uv=!!Wv&&+Wv[1],Vv=/MSIE|Trident/.test(P),Gv=P.match(/AppleWebKit\/(\d+)\./),Hv=!!Gv&&+Gv[1],$v=pe,Bv=Vt,Jv=Z,Kv=Ne,Qv=qr,Zv=u,td=Xv,ed=Ue,rd=Uv,nd=Vv,id=F,od=Hv,ad=[],ud=ad.sort,sd=Zv((function(){ad.sort(void 0)})),cd=Zv((function(){ad.sort(null)})),ld=ed("sort"),fd=!Zv((function(){if(id)return id<70;if(!(rd&&rd>3)){if(nd)return!0;if(od)return od<603;var t,e,r,n,i="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)ad.push({k:e+n,v:r})}for(ad.sort((function(t,e){return e.v-t.v})),n=0;n<ad.length;n++)e=ad[n].k.charAt(0),i.charAt(i.length-1)!==e&&(i+=e);return"DGBEFHACIJK"!==i}}));$v({target:"Array",proto:!0,forced:sd||!cd||!ld||!fd},{sort:function(t){void 0!==t&&Bv(t);var e=Jv(this);if(fd)return void 0===t?ud.call(e):ud.call(e,t);var r,n,i=[],o=Kv(e.length);for(n=0;n<o;n++)n in e&&i.push(e[n]);for(r=(i=td(i,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:Qv(e)>Qv(r)?1:-1}}(t))).length,n=0;n<r;)e[n]=i[n++];for(;n<o;)delete e[n++];return e}});var hd,pd=Ae("Array").sort,vd=Array.prototype,dd=function(t){var e=t.sort;return t===vd||t instanceof Array&&e===vd.sort?pd:e},yd=Ae("Array").values,gd=Ai,md=Array.prototype,bd={DOMTokenList:!0,NodeList:!0},_d=function(t){var e=t.values;return t===md||t instanceof Array&&e===md.values||bd.hasOwnProperty(gd(t))?yd:e},wd=Bs,Ed=Ae("Array").entries,Td=Ai,Od=Array.prototype,xd={DOMTokenList:!0,NodeList:!0},kd=function(t){var e=t.entries;return t===Od||t instanceof Array&&e===Od.entries||xd.hasOwnProperty(Td(t))?Ed:e},Ad=new Uint8Array(16);function Sd(){if(!hd&&!(hd="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return hd(Ad)}var jd=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;function Id(t){return"string"==typeof t&&jd.test(t)}for(var Pd=[],Dd=0;Dd<256;++Dd)Pd.push((Dd+256).toString(16).substr(1));function Ld(t,e,r){var n=(t=t||{}).random||(t.rng||Sd)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(var i=0;i<16;++i)e[r+i]=n[i];return e}return function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(Pd[t[e+0]]+Pd[t[e+1]]+Pd[t[e+2]]+Pd[t[e+3]]+"-"+Pd[t[e+4]]+Pd[t[e+5]]+"-"+Pd[t[e+6]]+Pd[t[e+7]]+"-"+Pd[t[e+8]]+Pd[t[e+9]]+"-"+Pd[t[e+10]]+Pd[t[e+11]]+Pd[t[e+12]]+Pd[t[e+13]]+Pd[t[e+14]]+Pd[t[e+15]]).toLowerCase();if(!Id(r))throw TypeError("Stringified UUID is invalid");return r}(n)}function Cd(t){return"string"==typeof t||"number"==typeof t}var Md=function(){function t(r){e(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(r)}return be(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Ql((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;dc(t=Nc(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:i},n}}]),t}(),Nd=function(){function t(){e(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return be(t,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");dc(n=rc(i=[]).call(i,Qs(this._subscribers[t]),Qs(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=_r(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}();cv("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Av);var Rd=k.Set,Fd=Jt,zd=Co,qd=function(t){var e=zd(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return Fd(e.call(t))};function Yd(t,e){var r=void 0!==Zs&&ha(t)||t["@@iterator"];if(!r){if(oc(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Xd(t,e);var n=nc(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return $o(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Xd(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Xd(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var Wd=function(t){function r(t){e(this,r),this._pairs=t}return be(r,[{key:t,value:Tp.mark((function t(){var e,r,n,i,o;return Tp.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Yd(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=$s(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Tp.mark((function t(){var e,r,n,i,o;return Tp.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Yd(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=$s(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Tp.mark((function t(){var e,r,n,i;return Tp.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Yd(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=$s(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Tp.mark((function t(){var e,r,n,i;return Tp.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Yd(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=$s(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Or(t=Qs(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Or(t=Qs(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Qs(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=Fl(null),r=Yd(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=$s(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Sv(this._pairs)}},{key:"toIdSet",value:function(){return new Rd(this.toIdArray())}},{key:"toItemSet",value:function(){return new Rd(this.toItemArray())}},{key:"cache",value:function(){return new r(Qs(this._pairs))}},{key:"distinct",value:function(t){var e,r=new Rd,n=Yd(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=$s(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(t){var e=this._pairs;return new r(ss({},wd,Tp.mark((function r(){var n,i,o,a,u;return Tp.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Yd(e),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=10;break}if(o=$s(i.value,2),a=o[0],u=o[1],!t(u,a)){r.next=8;break}return r.next=8,[a,u];case 8:r.next=3;break;case 10:r.next=15;break;case 12:r.prev=12,r.t0=r.catch(1),n.e(r.t0);case 15:return r.prev=15,n.f(),r.finish(15);case 18:case"end":return r.stop()}}),r,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=Yd(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=$s(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(t){var e=this._pairs;return new r(ss({},wd,Tp.mark((function r(){var n,i,o,a,u;return Tp.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Yd(e),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=9;break}return o=$s(i.value,2),a=o[0],u=o[1],r.next=7,[a,t(u,a)];case 7:r.next=3;break;case 9:r.next=14;break;case 11:r.prev=11,r.t0=r.catch(1),n.e(r.t0);case 14:return r.prev=14,n.f(),r.finish(14);case 17:case"end":return r.stop()}}),r,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=qd(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=$s(r.value,2),a=o[0],u=o[1],s=t(u,a);s>i&&(i=s,n=u)}return n}},{key:"min",value:function(t){var e=qd(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=$s(r.value,2),a=o[0],u=o[1],s=t(u,a);s<i&&(i=s,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=Yd(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=$s(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(t){var e=this;return new r(ss({},wd,(function(){var r;return qd(dd(r=Qs(e._pairs)).call(r,(function(e,r){var n=$s(e,2),i=n[0],o=n[1],a=$s(r,2),u=a[0],s=a[1];return t(o,s,i,u)})))})))}}]),r}(wd);function Ud(t,e){var r=sc(t);if(Ru){var n=Ru(t);e&&(n=_r(n).call(n,(function(e){return Hu(t,e).enumerable}))),r.push.apply(r,n)}return r}function Vd(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)dc(r=Ud(Object(n),!0)).call(r,(function(e){ss(t,e,n[e])}));else if(rs)as(t,rs(n));else{var i;dc(i=Ud(Object(n))).call(i,(function(e){us(t,e,Hu(n,e))}))}}return t}function Gd(t,e){var r=void 0!==Zs&&ha(t)||t["@@iterator"];if(!r){if(oc(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Hd(t,e);var n=nc(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return $o(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Hd(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Hd(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function $d(t){var e=function(){if("undefined"==typeof Reflect||!pp)return!1;if(pp.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(pp(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=wp(t);if(e){var i=wp(this).constructor;r=pp(n,arguments,i)}else r=n.apply(this,arguments);return bp(this,r)}}var Bd=function(t){gp(n,t);var r=$d(n);function n(t,i){var o;return e(this,n),(o=r.call(this))._queue=null,t&&!oc(t)&&(i=t,t=[]),o._options=i||{},o._data=new Sv,o.length=0,o._idProp=o._options.fieldId||"id",t&&t.length&&o.add(t),o.setOptions(i),o}return be(n,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=Md.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Ks(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if(oc(t)){var o=Or(t).call(t,(function(t){return t[n._idProp]}));if(Dv(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==Ks(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],u=this._idProp,s=function(t){var e=t[u];if(null!=e&&r._data.has(e)){var s=t,c=Hc({},r._data.get(e)),l=r._updateItem(s);i.push(l),a.push(s),o.push(c)}else{var f=r._addItem(t);n.push(f)}};if(oc(t))for(var c=0,l=t.length;c<l;c++)t[c]&&"object"===Ks(t[c])?s(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==Ks(t))throw new Error("Unknown dataType");s(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var f={items:i,oldData:o,data:a};this._trigger("update",f,e)}return rc(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;oc(t)||(t=[t]);var i=Or(r=Or(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return Jh.apply(void 0,rc(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:Or(i).call(i,(function(t){return t.id})),oldData:Or(i).call(i,(function(t){return t.oldData})),data:Or(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;Cd(t)?(r=t,i=e):oc(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",u=i&&_r(i),s=[],c=void 0,l=void 0,f=void 0;if(null!=r)(c=this._data.get(r))&&u&&!u(c)&&(c=void 0);else if(null!=n)for(var h=0,p=n.length;h<p;h++)null==(c=this._data.get(n[h]))||u&&!u(c)||s.push(c);else for(var v,d=0,y=(l=Qs(Rv(v=this._data).call(v))).length;d<y;d++)f=l[d],null==(c=this._data.get(f))||u&&!u(c)||s.push(c);if(i&&i.order&&null==r&&this._sort(s,i.order),i&&i.fields){var g=i.fields;if(null!=r&&null!=c)c=this._filterFields(c,g);else for(var m=0,b=s.length;m<b;m++)s[m]=this._filterFields(s[m],g)}if("Object"==a){for(var _={},w=0,E=s.length;w<E;w++){var T=s[w];_[T[this._idProp]]=T}return _}return null!=r?null!==(o=c)&&void 0!==o?o:null:s}},{key:"getIds",value:function(t){var e=this._data,r=t&&_r(t),n=t&&t.order,i=Qs(Rv(e).call(e)),o=[];if(r)if(n){for(var a=[],u=0,s=i.length;u<s;u++){var c=i[u],l=this._data.get(c);null!=l&&r(l)&&a.push(l)}this._sort(a,n);for(var f=0,h=a.length;f<h;f++)o.push(a[f][this._idProp])}else for(var p=0,v=i.length;p<v;p++){var d=i[p],y=this._data.get(d);null!=y&&r(y)&&o.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=i.length;m<b;m++){var _=i[m];g.push(e.get(_))}this._sort(g,n);for(var w=0,E=g.length;w<E;w++)o.push(g[w][this._idProp])}else for(var T=0,O=i.length;T<O;T++){var x=i[T],k=e.get(x);null!=k&&o.push(k[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&_r(e),n=this._data,i=Qs(Rv(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,u=o.length;a<u;a++){var s=o[a];t(s,s[this._idProp])}else for(var c=0,l=i.length;c<l;c++){var f=i[c],h=this._data.get(f);null==h||r&&!r(h)||t(h,f)}}},{key:"map",value:function(t,e){for(var r=e&&_r(e),n=[],i=this._data,o=Qs(Rv(i).call(i)),a=0,u=o.length;a<u;a++){var s=o[a],c=this._data.get(s);null==c||r&&!r(c)||n.push(t(c,s))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?Ke(r=oc(e)?e:sc(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;dd(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");dd(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=oc(t)?t:[t],o=0,a=i.length;o<a;o++){var u=this._remove(i[o]);if(u){var s=u[this._idProp];null!=s&&(r.push(s),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(Cd(t)?e=t:t&&"object"===Ks(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Qs(Rv(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=Gd(_d(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u>i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=Gd(_d(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u<i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=Qs(Rv(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var u=r[o],s=e.get(u)[t],c=!1,l=0;l<i;l++)if(n[l]==s){c=!0;break}c||void 0===s||(n[i]=s,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=Ld()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+$l(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,Vd(Vd({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new Wd(ss({},wd,Tp.mark((function r(){var n,i,o,a;return Tp.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Gd(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new Wd(ss({},wd,Ie(r=kd(this._data)).call(r,this._data)))}}]),n}(Nd);function Jd(t,e){var r=void 0!==Zs&&ha(t)||t["@@iterator"];if(!r){if(oc(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Kd(t,e);var n=nc(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return $o(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Kd(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Kd(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Qd(t){var e=function(){if("undefined"==typeof Reflect||!pp)return!1;if(pp.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(pp(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=wp(t);if(e){var i=wp(this).constructor;r=pp(n,arguments,i)}else r=n.apply(this,arguments);return bp(this,r)}}var Zd=function(t){gp(n,t);var r=Qd(n);function n(t,i){var o,a;return e(this,n),(a=r.call(this)).length=0,a._ids=new Rd,a._options=i||{},a._listener=Ie(o=a._onEvent).call(o,mp(a)),a.setData(t),a}return be(n,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:_r(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:_r(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new Bd;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:_r(this._options)}),e=Qs(this._ids),r={},n=[],i=[],o=[],a=0,u=t.length;a<u;a++){var s=t[a];r[s]=!0,this._ids.has(s)||(n.push(s),this._ids.add(s))}for(var c=0,l=e.length;c<l;c++){var f=e[c],h=this._data.get(f);null==h?console.error("If you see this, report it please."):r[f]||(i.push(f),o.push(h),this._ids.delete(f))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;Cd(t)||oc(t)?(n=t,r=e):r=t;var i=Hc({},this._options,r),o=_r(this._options),a=r&&_r(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=_r(this._options),n=null!=t?_r(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=_r(this._options),o=e&&_r(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,dc(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=_r(this._options),o=e&&_r(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,Or(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||ss({},wd,Ie(e=Rv(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,r="This data view has already been disposed of.",i={get:function(){throw new Error(r)},set:function(){throw new Error(r)},configurable:!1},o=Jd(ic(n.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;us(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],u=[],s=[],c=[];switch(t){case"add":for(var l=0,f=n.length;l<f;l++){var h=n[l];this.get(h)&&(this._ids.add(h),i.push(h))}break;case"update":for(var p=0,v=n.length;p<v;p++){var d=n[p];this.get(d)?this._ids.has(d)?(o.push(d),s.push(e.data[p]),u.push(e.oldData[p])):(this._ids.add(d),i.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),c.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),c.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:u,data:s},r),a.length&&this._trigger("remove",{items:a,oldData:c},r)}}}]),n}(Nd);function ty(t,e){return"object"===Ks(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof dc(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Or(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}t.DELETE=Bh,t.DataSet=Bd,t.DataStream=Wd,t.DataView=Zd,t.Queue=Md,t.createNewDataPipeFrom=function(t){return new Fr(t)},t.isDataSetLike=ty,t.isDataViewLike=function(t,e){return"object"===Ks(e)&&null!==e&&t===e.idProp&&"function"==typeof dc(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Or(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&ty(t,e.getDataSet())},Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-data.min.js.map
